{   CryptoAPI}


{      ;   
      ,  , 
   ,      ,
  }
const
  MaxMemBlock: Integer = 1024 * 1024;
{   CertAltNameEntry, AltNameChoice 
  , Value     ,
WideValue     , DirectoryNamePtr 
   , IPAddressPtr    IP-}
procedure DefineCertAltNameEntry(var CertAltNameEntry: TCertAltNameEntry;
  AltNameChoice: DWORD; Value: PAnsiChar; ValueWide: PWideChar;
  DirectoryNamePtr: PCertNameBLOB; IPAddressPtr: PCryptDataBLOB);

{  CryptoAPI}
type
  ECryptoAPIError = class(ECryptoError);
  ECryptoAPIVerifyError = class(ECryptoAPIError);
  ECryptoAPICancelError = class(ECryptoAPIError);
  ECryptoAPINoCertError = class(ECryptoAPIError);
  ECryptoAPICertValidityError = class(ECryptoAPIError);
  ECryptoAPICertValidityTimeError = class(ECryptoAPICertValidityError);
  ECryptoAPICertValidityRevokeError = class(ECryptoAPICertValidityError);
  ECryptoAPIOIDNotFoundError = class(ECryptoAPIError);
{   }
type
  ECryptoAPICAError = class(ECryptoAPIError);
  ECryptoAPICACertValidityError = class(ECryptoAPICAError);
{ True,     CryptoAPI, 
IsVerifyError = True -    }
function IsCryptoAPIError(E: TObject; IsVerifyError: Boolean): Boolean;

{    ProviderTypes,   nil, 
 }
function CryptoProviderTypes(ProviderTypes: TIndexedList): Integer;
{    ProviderName,   nil, 
  }
function CryptoProviderNames(ProviderNames: TIndexedStrings): Integer;
{   }
type
  TCryptoProviderTypeInfo = record
    ProvType: DWORD;  { }
    Name: string;     {      }
    TypeName: string; { ,     }
  end;
  PCryptoProviderTypeInfo = ^TCryptoProviderTypeInfo;
{   Value}
procedure InitCryptoProviderTypeInfo(out Value: TCryptoProviderTypeInfo);
{     ProviderType}
function CryptoProviderTypeInfo(ProviderType: DWORD): TCryptoProviderTypeInfo;
{   }
type
  TCryptoProviderNameInfo = record
    Name: string;      { }
    ImagePath: string; { }
    Signature: string; {,     }
    AType: DWORD;      { }
    LibSignatureRetrieved: Boolean; {    }
    LibHasSignature: Boolean;       {  -  }
  end;
  PCryptoProviderNameInfo = ^TCryptoProviderNameInfo;
{   Value}
procedure InitCryptoProviderNameInfo(out Value: TCryptoProviderNameInfo);
{    ,  , ,   
   ImagePath,     ,  
  8  ,    ,  
 #$00, #$01, #$00, #$00, #$28, #$01, #$00, #$00}
function CryptoProviderLibSignature(const ImagePath: string): string;
{     ProviderName, 
RetrieveLibSignature = True      
,       
TCryptoProviderNameInfo.Signature ,  RetrieveLibSignature = False
     ,     ,  
  ,  TCryptoProviderNameInfo.Signature 
 }
function CryptoProviderNameInfo(const ProviderName: string;
  RetrieveLibSignature: Boolean): TCryptoProviderNameInfo;
{   }
type
  TCryptoProviderAlgInfo = record
    AlgId: TAlgId;       { }
    DefaultLen: DWORD;   {    }
    MinLen: DWORD;       {    }
    MaxLen: DWORD;       {    }
    Protocols: DWORD;    {,   0}
    Name: string;        {  ,  20 }
    LongName: string;    {  ,  40 }
    IsExtended: Boolean; {True -    PROV_ENUMALGS_EX}
  end;
  PCryptoProviderAlgInfo = ^TCryptoProviderAlgInfo;
{   Value}
procedure InitCryptoProviderAlgInfo(out Value: TCryptoProviderAlgInfo);
{ TCryptoProviderAlgInfo  EnumAlgs  PROV_ENUMALGS
(CryptoProviderEnumAlgsToAlgInfo);  TCryptoProviderAlgInfo 
EnumAlgsEx  PROV_ENUMALGS_EX}
function CryptoProviderEnumAlgsToAlgInfo(const EnumAlgs: TProvEnumAlgs):
  TCryptoProviderAlgInfo;
function CryptoProviderEnumAlgsExToAlgInfo(const EnumAlgsEx: TProvEnumAlgsEx):
  TCryptoProviderAlgInfo;
{    }
type
  TCryptoProviderDefAlgInfo = record
    SignAlgId: TAlgId;  {, AT_SIGNATURE,  CALG_RSA_SIGN}
    MsgAlgId: TAlgId;   {  }
    CryptAlgId: TAlgId; { ,  GALG_RC2, CALG_RC4}
    HashAlgId: TAlgId;  {,  CALG_MD2, CALG_MD5, CALG_SHA}
    ExchAlgId: TAlgId;  { , AT_KEYEXCHANGE,  CALG_RSA_KEYX}
    AlgCount: Integer;  {  }
  end;
  PCryptoProviderDefAlgInfo = ^TCryptoProviderDefAlgInfo;
{   Value}
procedure InitCryptoProviderDefAlgInfo(out Value: TCryptoProviderDefAlgInfo);
{  AlgId     DefAlg,  
      ,    0, 
ForceUpdate = True     ,  True,
        }
function CryptProviderUpdateDefAlgInfo(var DefAlgInfo:
  TCryptoProviderDefAlgInfo; AlgId: TAlgId; ForceUpdate: Boolean): Boolean;
{  TCryptoProviderTypeInfo}
type
  TCryptoProviderTypesInfo = class(TObjectStd)
  private
    FList: TList;
    FChanged: Boolean;
  protected
    function GetCapacity: Integer;
    procedure SetCapacity(NewCapacity: Integer);
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
    function GetItem(Index: Integer): TCryptoProviderTypeInfo;
    procedure SetItem(Index: Integer; const Value: TCryptoProviderTypeInfo);
    function GetItemPtr(Index: Integer): PCryptoProviderTypeInfo;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  (Clear);   Value,   
    (Add);   Value   Index (Insert); 
       Index (Delete)}
    procedure Clear;
    function Add(const Value: TCryptoProviderTypeInfo): Integer;
    procedure Insert(Index: Integer; const Value: TCryptoProviderTypeInfo);
    procedure Delete(Index: Integer);
    {}
    {  (Capacity);   (Count);  
       Index (Items);     ,
        nil (ItemPtrs);   
    True,   ,     (Changed)}
    property Capacity: Integer read GetCapacity write SetCapacity;
    property Count: Integer read GetCount write SetCount;
    property Items[Index: Integer]: TCryptoProviderTypeInfo
      read GetItem write SetItem; default;
    property ItemPtrs[Index: Integer]: PCryptoProviderTypeInfo read GetItemPtr;
    property Changed: Boolean read FChanged write FChanged;
  end;
{  TCryptoProviderNameInfo}
type
  TCryptoProviderNamesInfo = class(TObjectStd)
  private
    FList: TList;
    FChanged: Boolean;
  protected
    function GetCapacity: Integer;
    procedure SetCapacity(NewCapacity: Integer);
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
    function GetItem(Index: Integer): TCryptoProviderNameInfo;
    procedure SetItem(Index: Integer; const Value: TCryptoProviderNameInfo);
    function GetItemPtr(Index: Integer): PCryptoProviderNameInfo;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  (Clear);   Value,   
    (Add);   Value   Index (Insert); 
       Index (Delete)}
    procedure Clear;
    function Add(const Value: TCryptoProviderNameInfo): Integer;
    procedure Insert(Index: Integer; const Value: TCryptoProviderNameInfo);
    procedure Delete(Index: Integer);
    {}
    {  (Capacity);   (Count);  
       Index (Items);     ,
        nil (ItemPtrs);   
    True,   ,     (Changed)}
    property Capacity: Integer read GetCapacity write SetCapacity;
    property Count: Integer read GetCount write SetCount;
    property Items[Index: Integer]: TCryptoProviderNameInfo
      read GetItem write SetItem; default;
    property ItemPtrs[Index: Integer]: PCryptoProviderNameInfo read GetItemPtr;
    property Changed: Boolean read FChanged write FChanged;
  end;
{  TCryptoProviderAlgInfo}
type
  TCryptoProviderAlgsInfo = class(TObjectStd)
  private
    FList: TList;
    FChanged: Boolean;
  protected
    function GetCapacity: Integer;
    procedure SetCapacity(NewCapacity: Integer);
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
    function GetItem(Index: Integer): TCryptoProviderAlgInfo;
    procedure SetItem(Index: Integer; const Value: TCryptoProviderAlgInfo);
    function GetItemPtr(Index: Integer): PCryptoProviderAlgInfo;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  (Clear);   Value,   
    (Add);   Value   Index (Insert); 
       Index (Delete)}
    procedure Clear;
    function Add(const Value: TCryptoProviderAlgInfo): Integer;
    procedure Insert(Index: Integer; const Value: TCryptoProviderAlgInfo);
    procedure Delete(Index: Integer);
    {}
    {  (Capacity);   (Count);  
       Index (Items);     ,
        nil (ItemPtrs);   
    True,   ,     (Changed)}
    property Capacity: Integer read GetCapacity write SetCapacity;
    property Count: Integer read GetCount write SetCount;
    property Items[Index: Integer]: TCryptoProviderAlgInfo
      read GetItem write SetItem; default;
    property ItemPtrs[Index: Integer]: PCryptoProviderAlgInfo read GetItemPtr;
    property Changed: Boolean read FChanged write FChanged;
  end;
{  TCryptoProviderDefAlgInfo}
type
  TCryptoProviderDefAlgsInfo = class(TObjectStd)
  private
    FList: TList;
    FChanged: Boolean;
  protected
    function GetCapacity: Integer;
    procedure SetCapacity(NewCapacity: Integer);
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
    function GetItem(Index: Integer): TCryptoProviderDefAlgInfo;
    procedure SetItem(Index: Integer; const Value: TCryptoProviderDefAlgInfo);
    function GetItemPtr(Index: Integer): PCryptoProviderDefAlgInfo;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  (Clear);   Value,   
    (Add);   Value   Index (Insert); 
       Index (Delete)}
    procedure Clear;
    function Add(const Value: TCryptoProviderDefAlgInfo): Integer;
    procedure Insert(Index: Integer; const Value: TCryptoProviderDefAlgInfo);
    procedure Delete(Index: Integer);
    {}
    {  (Capacity);   (Count);  
       Index (Items);     ,
        nil (ItemPtrs);   
    True,   ,     (Changed)}
    property Capacity: Integer read GetCapacity write SetCapacity;
    property Count: Integer read GetCount write SetCount;
    property Items[Index: Integer]: TCryptoProviderDefAlgInfo
      read GetItem write SetItem; default;
    property ItemPtrs[Index: Integer]: PCryptoProviderDefAlgInfo
      read GetItemPtr;
    property Changed: Boolean read FChanged write FChanged;
  end;

{  }
const
  EncodedEmptyStr = #$05#$00;
{    Base64     }
const
  EncodedCertLineLen = 64;
{  CryptoAPI,       }
type
  TComplexKey = record
    ExchKey: string;
    SignKey: string;
  end;
{   CryptoAPI  }
function ComplexKeyToStr(const ComplexKey: TComplexKey): string;
{     CryptoAPI}
function StrToComplexKey(const S: string): TComplexKey;

{ : RSA       ;
RSA  128- ; RSA  40- ; GOST}
type
  TCryptoAlgorithm = (caRSA, caRSA128, caRSA40, caDSS, caGOST,
    caMD5RSA, caSHA1RSA, caGOST2001);
{ BLOB CryptoAPI  }
function CryptBlobToStr(CryptBlob: PCryptIntegerBLOB): string;
{  BLOB CryptoAPI  ,   
}
function CryptBitBlobToStr(CryptBitBlob: PCryptBitBLOB): string;
{  CryptoAPI}
function ItemVersion(Version: DWORD): Integer;
{ }
function CertVersion(CertInfo: PCertInfo): Integer;
{ }
function RequestVersion(RequestInfo: PCertRequestInfo): Integer;
{   }
function CertNotBefore(CertInfo: PCertInfo;
  IsReturnLocalTime: Boolean): TDateTime;
{   }
function CertNotAfter(CertInfo: PCertInfo;
IsReturnLocalTime: Boolean): TDateTime;
{       }
function CertSerialNumber(CertInfo: PCertInfo): string;
{  ;      
 }
function CertCompareSerialNumbers(const CerialNumber1,
  CerialNumber2: string): Boolean;
{ OID   }
function CertSignatureAlgOID(CertInfo: PCertInfo): string;
{     }
function ProvTypeToStr(ProvType: DWORD): string;
{      }
function StrToProvType(const S: string; DefProvType: DWORD): DWORD;
{   OID}
type
  TCryptOIDInfo = record
    GroupId: DWORD;
    OID: string;
    Name: string;
    AlgId: TAlgId;
  end;
  TNullCryptOIDInfo = record
    NotNull: Boolean;
    Value: TCryptOIDInfo;
  end;
{   Value (InitCryptOIDInfo, InitNullCryptOIDInfo)}
procedure InitCryptOIDInfo(out Value: TCryptOIDInfo);
procedure InitNullCryptOIDInfo(out Value: TNullCryptOIDInfo);
{      OID OIDInfoPtr   
 TNullCryptOIDInfo}
function CryptOIDInfoPtrToNullInfo(OIDInfoPtr: PCCryptOIDInfo):
  TNullCryptOIDInfo;
{ OID   }
function AlgOIDToStr(const AlgOID: string): string;
{   HashAlgId      OID
 ,    ,   
  ,  OIDOnly = True   OID, PubAlgId
        0,   
       PubAltAlgId  
 }
function HashAlgToAlgOIDOrName(HashAlgId, PubAlgId, PubAltAlgId: TAlgId;
  OIDOnly: Boolean): string;
{     OID  
 AlgOID,   OID  0}
function AlgOIDToHashAlgId(const AlgOID: string): TAlgId;
{   OID AlgOID   }
function AlgOIDToProvType(const AlgOID: string): DWORD;
{  CERT_RDN_ATTR.Value  }
function CryptValueToStr(const Value: string; ValueType: DWORD): string;
{ CERT_NAME_INFO     ; 
IsAscendingOrder = True      ,
 -    }
procedure CertNameInfoToLists(CertNameInfo: PCertNameInfo;
  Params, Values: TStrings; IsAscendingOrder: Boolean);
{ CertNameInfo  CERT_NAME_INFO   ,  
 X500ParamsToStr,  IsAscendingOrder = True 
    ,  -    }
function CertNameInfoToStr(CertNameInfo: PCertNameInfo;
  IsAscendingOrder: Boolean): string;
{,   MainValues   SubValues ( )}
function CertCompareNameListsInclude(MainParams, MainValues,
  SubParams, SubValues: TStrings): Boolean;
{ OID    }
function CertCryptAlgOID(CertInfo: PCertInfo): string;
{ OID    }
function RequestCryptAlgOID(RequestInfo: PCertRequestInfo): string;
{     }
function CertKeyBits(CertKeyLen: Integer): Integer;
{   CryptoAPI    
    PublicKeyInfo (ItemPublicKey); 
    PublicKeyInfoToStr    PublicKeyInfo
(ItemPublicKeyInfo)}
function ItemPublicKey(PublicKeyInfo: PCertPublicKeyInfo): string;
function ItemPublicKeyInfo(PublicKeyInfo: PCertPublicKeyInfo): string;
{  CertInfo       
  (CertPublicKey);   CertInfo 
      PublicKeyInfoToStr
(CertPublicKeyInfoStr)}
function CertPublicKey(CertInfo: PCertInfo): string;
function CertPublicKeyInfoStr(CertInfo: PCertInfo): string;
{  RequestInfo       
  (RequestPublicKey);   RequestInfo
       PublicKeyInfoToStr
(RequestPublicKeyInfo)}
function RequestPublicKey(RequestInfo: PCertRequestInfo): string;
function RequestPublicKeyInfo(RequestInfo: PCertRequestInfo): string;
{      }
function CertPublicKeyBits(CertInfo: PCertInfo): Integer;
{      }
function RequestPublicKeyBits(RequestInfo: PCertRequestInfo): Integer;
{    }
type
  TCertPubKeyInfo = record
    AlgorithmId: string;
    AlgorithmParams: string;
    PublicKey: string;
    PublicKeyUnusedBits: Integer;
  end;
  PCertPubKeyInfo = ^TCertPubKeyInfo;
{   Value}
procedure InitCertPubKeyInfo(out Value: TCertPubKeyInfo);
{   AlgorithmId    AlgorithmParams,
  PublicKey,      
PublicKeyUnusedBits   TCertPubKeyInfo}
function CertPubKeyInfo(const AlgorithmId, AlgorithmParams,
  PublicKey: string; PublicKeyUnusedBits: Integer): TCertPubKeyInfo;
{   TCertPubKeyInfo}
function CertPubKeyInfoEmpty: TCertPubKeyInfo;
{      }
function PubKeyInfoToStr(const PubKeyInfo: TCertPubKeyInfo): string;
{      }
function StrToPubKeyInfo(const S: string): TCertPubKeyInfo;
{     PublicKeyInfo  
TCertPubKeyInfo}
function GetCertPubKeyInfo(const PublicKeyInfo:
  TCertPublicKeyInfo): TCertPubKeyInfo;
{    CertInfo   TCertPubKeyInfo}
function CertItemPubKeyInfo(CertInfo: PCertInfo): TCertPubKeyInfo;
{  CERT_PUBLIC_KEY_INFO (   
  PubKeyInfo)}
function StructCertPublicKeyInfo(const PubKeyInfo: TCertPubKeyInfo):
  TCertPublicKeyInfo;
{  PubKeyInfo      CERT_PUBLIC_KEY_INFO}
function CertPubKeyInfoToBuf(const PubKeyInfo: TCertPubKeyInfo): TSizedBufInfo;
{ TCertPubKeyInfo}
function CompCertPubKey(const CertPubKeyInfo1,
  CertPubKeyInfo2: TCertPubKeyInfo): Boolean;
{    , PubKey     
, PubKeyInfo -     , 
UseCertKeyFormat = True   ,  PubKeyInfo ,
      ,   
,    PubKey (ExportPublicKey); 
   ExportPublicKey  ExportedPublicKey, 
   ,  PubKey    
PubKeyInfo      (ImportPublicKey); 
 ,    ExportPublicKey,
ExportedPublicKey    ,   
  ,     
   (PublicKeyData);   
ExportedPublicKey, caRSA128, caGOST  caGOST2001,   
 caRSA}
function ExportPublicKey(const PubKey, PubKeyInfo: string;
  UseCertKeyFormat: Boolean): string;
procedure ImportPublicKey(const ExportedPublicKey: string;
  out PubKey, PubKeyInfo: string);
function PublicKeyData(const ExportedPublicKey: string): string;
function PublicKeyAlg(const ExportedPublicKey: string): TCryptoAlgorithm;
{  PublicKeyData  }
type
  TCAPIPublicKeyDataMethod = function(const ExportedPublicKey: string): string
    of object;
{     ;  P  nil,   
 P  Len;  -  Stream  nil,    ;  -
  ;     ,     
        P,    
    ,     S}
type
  TDataInfo = record
    P: Pointer;
    Len: Integer;
    S: string;
    Stream: TStream;
  end;
{   Value}
procedure InitDataInfo(out Value: TDataInfo);
{  TDataInfo}
function DataInfo(P: Pointer; Len: Integer; const S: string;
  Stream: TStream): TDataInfo;
{  TDataInfo     ,   }
function BufAsData(P: Pointer; Len: Integer): TDataInfo;
function StrAsData(const S: string): TDataInfo;
function StreamAsData(Stream: TStream): TDataInfo;
{   ;  CertContext  nil,   
;  -    }
type
  TCertFindInfo = record
    CertContext: PCCertContext;
    StoreHandle: THCertStore;
    Certificate: string;
    CryptAlg: string;
    SignatureAlg: string;
    SerialNumber: string;
    IsCheckDate: Boolean;
    ActualDate: TDateTime;
    IsLocalDate: Boolean;
    IssuerAbbrs: TStrings;
    IssuerValues: TStrings;
    SubjectAbbrs: TStrings;
    SubjectValues: TStrings;
    IsCheckPublicKey: Boolean;
    PubKeyInfo: TCertPubKeyInfo;
    IsWithPrivateKey: Boolean;
    Provider: string;
    Container: string;
    PubKeyHandle: THCryptKey; {  ,  }
    SymmetricKey: string;     {     .}
  end;
  PCertFindInfo = ^TCertFindInfo;
{   Value}
procedure InitCertFindInfo(out Value: TCertFindInfo);
{ TCertFindInfo}
function CertFindInfo(CertContext: PCCertContext; StoreHandle: THCertStore;
  const Certificate, CryptAlg, SignatureAlg, SerialNumber: string;
  IsCheckDate: Boolean; ActualDate: TDateTime; IsLocalDate: Boolean;
  IssuerAbbrs, IssuerValues, SubjectAbbrs, SubjectValues: TStrings;
  IsCheckPublicKey: Boolean; const PubKeyInfo: TCertPubKeyInfo;
  IsWithPrivateKey: Boolean; const Provider, Container: string;
  PubKeyHandle: THCryptKey; const SymmetricKey: string): TCertFindInfo;
{ TCertFindInfo}
function CompCertFindInfo(const CertFindInfo1,
  CertFindInfo2: TCertFindInfo): Boolean;
{ ,    TCertFindInfo}
procedure FreeCertFindInfo(const CertFindInfo: TCertFindInfo);
{  TCertFindInfo}
type
  TCertFindsInfo = class(TObjectStd)
  private
    FList: TList;
    FChanged: Boolean;
  protected
    function GetCapacity: Integer;
    procedure SetCapacity(NewCapacity: Integer);
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
    function GetItem(Index: Integer): TCertFindInfo;
    procedure SetItem(Index: Integer; const Value: TCertFindInfo);
    function GetItemPtr(Index: Integer): PCertFindInfo;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  (Clear);   Value,   
    (Add);   Value   Index (Insert); 
       Index (Delete)}
    procedure Clear;
    function Add(const Value: TCertFindInfo): Integer;
    procedure Insert(Index: Integer; const Value: TCertFindInfo);
    procedure Delete(Index: Integer);
    {}
    {  (Capacity);   (Count);  
       Index (Items);     ,
        nil (ItemPtrs);   
    True,   ,     (Changed)}
    property Capacity: Integer read GetCapacity write SetCapacity;
    property Count: Integer read GetCount write SetCount;
    property Items[Index: Integer]: TCertFindInfo read GetItem write SetItem;
      default;
    property ItemPtrs[Index: Integer]: PCertFindInfo read GetItemPtr;
    property Changed: Boolean read FChanged write FChanged;
  end;
{  :   ,
      ,  
  ,     ,
      }
type
  TCryptoProviderMode = (cpmAuto, cpmDefault, cpmHigh, cpmLow);
{  ;  Provider -  ,  
     Mode}
type
  TCryptoProviderInfo = record
    ProvType: DWORD;
    Provider: string;
    ProvMode: TCryptoProviderMode;
  end;
{   Value}
procedure InitCryptoProviderInfo(out Value: TCryptoProviderInfo);
{ TCryptoProviderInfo}
function CryptoProviderInfo(ProvType: DWORD; const Provider: string;
  ProvMode: TCryptoProviderMode): TCryptoProviderInfo;
{ TCryptoProviderInfo      }
procedure CryptoProviderInfoToStrings(
  const CryptoProviderInfo: TCryptoProviderInfo; Strings: TStrings);
procedure StringsToCryptoProviderInfo(Strings: TStrings; var Index: Integer;
  var CryptoProviderInfo: TCryptoProviderInfo);
{   ;  IsNew = True    
Name,  -  IsExisting     Container
( IsAllowCreate = True     - ), 
 IsCertFindInfoDefined = True      
CertFindInfo,   Handle <> 0    
  }
type
  TContainerInfo = record
    IsNew: Boolean;
    IsExisting: Boolean;
    IsAllowCreate: Boolean;
    Container: string;
    IsCertFindInfoDefined: Boolean;
    CertFindInfo: TCertFindInfo;
    StoreName: string;
    Handle: THCryptProv;
  end;
{   Value}
procedure InitContainerInfo(out Value: TContainerInfo);
{ TContainerInfo}
function ContainerInfo(IsNew, IsExisting, IsAllowCreate: Boolean;
  const Container: string; IsCertFindInfoDefined: Boolean;
  const CertFindInfo: TCertFindInfo; StoreName: string;
  Handle: THCryptProv): TContainerInfo;
{   ;  Key,    ;
 - Handle;  Handle = 0,     ( IsGenerate =
True - )}
type
  TPrivateKeyInfo = record
    Key: string;
    Password: string;
    Handle: THCryptKey;
    IsGenerate: Boolean;
  end;
{   Value}
procedure InitPrivateKeyInfo(out Value: TPrivateKeyInfo);
{ TPrivateKeyInfo}
function PrivateKeyInfo(const Key, Password: string;
  Handle: THCryptKey; IsGenerate: Boolean): TPrivateKeyInfo;
{ TPrivateKeyInfo}
function CompPrivateKeys(const PrivateKey1,
  PrivateKey2: TPrivateKeyInfo): Boolean;
{   ;  Key,    ;
 - PubKeyInfo;  IsPubKeyInfoDefined = False - CertFindInfo (
CertFindInfo.CertContext = nil  CertFindInfo.StoreHandle = 0 
 StoreName); IsCertFindInfoDefined = False - Handle;  Handle = 0,
   }
type
  TPublicKeyInfo = record
    Key: string;
    IsPubKeyInfoDefined: Boolean;
    PubKeyInfo: TCertPubKeyInfo;
    IsCertFindInfoDefined: Boolean;
    CertFindInfo: TCertFindInfo;
    StoreName: string;
    Handle: THCryptKey;
  end;
{   Value}
procedure InitPublicKeyInfo(out Value: TPublicKeyInfo);
{ TPublicKeyInfo}
function PublicKeyInfo(const Key: string; IsPubKeyInfoDefined: Boolean;
  const PubKeyInfo: TCertPubKeyInfo; IsCertFindInfoDefined: Boolean;
  const CertFindInfo: TCertFindInfo; const StoreName: string;
  Handle: THCryptKey): TPublicKeyInfo;
{ TPublicKeyInfo}
function CompPublicKeys(const PublicKey1, PublicKey2: TPublicKeyInfo): Boolean;
{   ;    Key;  Key = '',
   ;  IsDerive = False  Handle; 
Handle = 0 -   }
type
  TSymmetricKeyInfo = record
    Key: string;
    IsDerive: Boolean;
    Password: string;
    Handle: THCryptKey;
  end;
{   Value}
procedure InitSymmetricKeyInfo(out Value: TSymmetricKeyInfo);
{ TSymmetricKeyInfo}
function SymmetricKeyInfo(const Key: string; IsDerive: Boolean;
Password: string; Handle: THCryptKey): TSymmetricKeyInfo;
{   }
type
  TAlgsInfo = record
    KeySpec: DWORD;
    SignKeySpec: DWORD;
    AlgId: TAlgId;
    DeriveAlgId: TAlgId;
    HashAlgId: TAlgId;
  end;
{   Value}
procedure InitAlgsInfo(out Value: TAlgsInfo);
{ TAlgsInfo}
function AlgsInfo(KeySpec, SignKeySpec: DWORD; AlgId, DeriveAlgId,
HashAlgId: TAlgId): TAlgsInfo;
{   }
type
  TFlagsInfo = record
    AcquireFlags: DWORD;    {SILENT}
    ReleaseFlags: DWORD;    {0}
    PrivImportFlags: DWORD; {EXPORTABLE, OAEP, NO_SALT}
    PubImportFlags: DWORD;  {0}
    ImportFlags: DWORD;     {0}
    PrivGenKeyFlags: DWORD; {USER_PROTECTED, EXPORTABLE, SALT, NO_SALT, PREGEN}
    GenKeyFlags: DWORD;     {EXPORTABLE, SALT, NO_SALT, PREGEN}
    DeriveFlags: DWORD;     {EXPORTABLE, SALT, NO_SALT, UPDATE_KEY}
    ExportFlags: DWORD;     {DESTROYKEY, SSL2_FALLBACK, OAEP}
    HashFlags: DWORD;       {0}
    HashingFlags: DWORD;    {USERDATA}
    HashParamFlags: DWORD;  {0}
    SignFlags: DWORD;       {NOHASHOID}
    VerifyFlags: DWORD;     {NOHASHOID}
  end;
{   Value}
procedure InitFlagsInfo(out Value: TFlagsInfo);
{ TFlagsInfo}
function FlagsInfo(AcquireFlags, ReleaseFlags, PrivImportFlags,
  PubImportFlags, ImportFlags, PrivGenKeyFlags, GenKeyFlags, DeriveFlags,
  ExportFlags, HashFlags, HashingFlags, HashParamFlags, SignFlags,
  VerifyFlags: DWORD): TFlagsInfo;
{   }
type
  TDataCfg = record
    { }
    FileName: string;
    {,      ,      
      ,     }
    FilePos: Integer;
    {, ,    }
    S: string;
  end;
{   Value}
procedure InitDataCfg(out Value: TDataCfg);
{ TDataCfg}
function DataCfg(const FileName, S: string): TDataCfg;
{ TDataCfg      }
procedure DataCfgToStrings(const DataCfg: TDataCfg; Strings: TStrings);
procedure StringsToDataCfg(Strings: TStrings; var Index: Integer;
  var DataCfg: TDataCfg);
{ TDataCfg  TDataInfo   }
function DataCfgToInfo(const DataCfg: TDataCfg; StreamMode: Word): TDataInfo;
{ ,    TDataInfo}
procedure FreeDataInfo(const DataInfo: TDataInfo);
{  }
type
  TCertFindCfg = record
    Certificate: string;
    SerialNumber: string;
    ActualSysDate: TDateTime;
    Issuer: TX500;
    Subject: TX500;
  end;
  PCertFindCfg = ^TCertFindCfg;
{   Value}
procedure InitCertFindCfg(out Value: TCertFindCfg);
{ TCertFindCfg,   TCertFindInfo}
function CertFindCfg(const Certificate, SerialNumber: string;
  ActualSysDate: TDateTime; const Issuer, Subject: TX500): TCertFindCfg;
{ True,  CertFindCfg    }
function IsCertFindCfgEmpty(const CertFindCfg: TCertFindCfg): Boolean;
{  TCertFindCfg}
type
  TCertFindsCfg = class(TObjectStd)
  private
    FList: TList;
    FChanged: Boolean;
  protected
    function GetCapacity: Integer;
    procedure SetCapacity(NewCapacity: Integer);
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
    function GetItem(Index: Integer): TCertFindCfg;
    procedure SetItem(Index: Integer; const Value: TCertFindCfg);
    function GetItemPtr(Index: Integer): PCertFindCfg;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  (Clear);   Value,   
    (Add);   Value   Index (Insert); 
       Index (Delete)}
    procedure Clear;
    function Add(const Value: TCertFindCfg): Integer;
    procedure Insert(Index: Integer; const Value: TCertFindCfg);
    procedure Delete(Index: Integer);
    {}
    {  (Capacity);   (Count);  
       Index (Items);     ,
        nil (ItemPtrs);   
    True,   ,     (Changed)}
    property Capacity: Integer read GetCapacity write SetCapacity;
    property Count: Integer read GetCount write SetCount;
    property Items[Index: Integer]: TCertFindCfg read GetItem write SetItem;
      default;
    property ItemPtrs[Index: Integer]: PCertFindCfg read GetItemPtr;
    property Changed: Boolean read FChanged write FChanged;
  end;
{ TCertFindCfg      }
procedure CertFindCfgToStrings(const CertFindCfg: TCertFindCfg;
  Strings: TStrings);
procedure StringsToCertFindCfg(Strings: TStrings; var Index: Integer;
  var CertFindCfg: TCertFindCfg);
{ TCertFindCfg  TCertFindInfo   ,
IsWithPrivateKey        
  (CertFindCfgToInfo);    CertFindsCfg
 CertFindsInfo, IsWithPrivateKey    
     }
function CertFindCfgToInfo(const CertFindCfg: TCertFindCfg;
  IsWithPrivateKey: Boolean): TCertFindInfo;
procedure CertFindsCfgToInfo(CertFindsCfg: TCertFindsCfg;
  CertFindsInfo: TCertFindsInfo; IsWithPrivateKey: Boolean);
{ ,   TContainerInfo}
type
  TContainerCfg = record
    Container: string;
    IsAllowCreate: Boolean;
    CertFindCfg: TCertFindCfg;
    StoreName: string;
  end;
{   Value}
procedure InitContainerCfg(out Value: TContainerCfg);
{ TContainerCfg}
function ContainerCfg(const Container: string; IsAllowCreate: Boolean;
  const CertFindCfg: TCertFindCfg; const StoreName: string): TContainerCfg;
{ TContainerCfg      }
procedure ContainerCfgToStrings(const ContainerCfg: TContainerCfg;
  Strings: TStrings);
procedure StringsToContainerCfg(Strings: TStrings; var Index: Integer;
  var ContainerCfg: TContainerCfg);
{ TContainerCfg  TContainerInfo   }
function ContainerCfgToInfo(const ContainerCfg: TContainerCfg;
  IsWithPrivateKey: Boolean): TContainerInfo;
{ ,    TContainerInfo}
procedure FreeContainerInfo(const ContainerInfo: TContainerInfo);
{  ,   TPrivateKeyInfo}
type
  TPrivateKeyCfg = record
    Key: string;
    Password: string;
    IsGenerate: Boolean;
  end;
{   Value}
procedure InitPrivateKeyCfg(out Value: TPrivateKeyCfg);
{ TPrivateKeyCfg}
function PrivateKeyCfg(const Key, Password: string;
IsGenerate: Boolean): TPrivateKeyCfg;
{ TPrivateKeyCfg      }
procedure PrivateKeyCfgToStrings(const PrivateKeyCfg: TPrivateKeyCfg;
  Strings: TStrings);
procedure StringsToPrivateKeyCfg(Strings: TStrings; var Index: Integer;
  var PrivateKeyCfg: TPrivateKeyCfg);
{ TPrivateKeyCfg  TPrivateKeyInfo}
function PrivateKeyCfgToInfo(const PrivateKeyCfg:
TPrivateKeyCfg): TPrivateKeyInfo;
{  ,   TPublicKeyInfo}
type
  TPublicKeyCfg = record
    Key: string;               {   CryptExportKey}
    KeyInfo: string;           {   CryptExportPublicKeyInfo}
    CertFindCfg: TCertFindCfg; {   }
    StoreName: string;         {}
  end;
{   Value}
procedure InitPublicKeyCfg(out Value: TPublicKeyCfg);
{ TPublicKeyCfg,   TPublicKeyInfo}
function PublicKeyCfg(const Key, KeyInfo: string; CertFindCfg: TCertFindCfg;
  const StoreName: string): TPublicKeyCfg;
{ TPublicKeyCfg      }
procedure PublicKeyCfgToStrings(const PublicKeyCfg: TPublicKeyCfg;
  Strings: TStrings);
procedure StringsToPublicKeyCfg(Strings: TStrings; var Index: Integer;
  var PublicKeyCfg: TPublicKeyCfg);
{ TPublicKeyCfg  TPublicKeyInfo   }
function PublicKeyCfgToInfo(const PublicKeyCfg: TPublicKeyCfg;
  IsWithPrivateKey: Boolean): TPublicKeyInfo;
{ ,    TPublicKeyInfo}
procedure FreePublicKeyInfo(const PublicKeyInfo: TPublicKeyInfo);
{  ,   TSymmetricKeyInfo}
type
  TSymmetricKeyCfg = record
    Key: string;
    IsDerive: Boolean;
    Password: string;
  end;
{   Value}
procedure InitSymmetricKeyCfg(out Value: TSymmetricKeyCfg);
{ TSymmetricKeyCfg}
function SymmetricKeyCfg(const Key: string; IsDerive: Boolean;
  const Password: string): TSymmetricKeyCfg;
{ TSymmetricKeyCfg      }
procedure SymmetricKeyCfgToStrings(const SymmetricKeyCfg: TSymmetricKeyCfg;
  Strings: TStrings);
procedure StringsToSymmetricKeyCfg(Strings: TStrings; var Index: Integer;
  var SymmetricKeyCfg: TSymmetricKeyCfg);
{ TSymmetricKeyCfg  TSymmetricKeyInfo}
function SymmetricKeyCfgToInfo(const SymmetricKeyCfg:
  TSymmetricKeyCfg): TSymmetricKeyInfo;
{   }
type
  TCertReqInfo = record
    Subject: TX500;
    CertUsage: string;
    RequestStoreFlags: DWORD;
    IsDeleteRequest: Boolean;
    CertContainer: string;
    CertPublicKey: string;
    CertRequest: string;
  end;
{   Value}
procedure InitCertReqInfo(out Value: TCertReqInfo);
{ TCertReqInfo      }
procedure CertReqInfoToStrings(const CertReqInfo: TCertReqInfo;
  Strings: TStrings);
procedure StringsToCertReqInfo(Strings: TStrings; var Index: Integer;
  var CertReqInfo: TCertReqInfo);
{ OID     ('CLIENT', 'SERVER',
'CODE', 'EMAIL')   (  -  )}
function CertUsageOIDToName(const CertUsage: string): string;
function CertUsageNameToOID(const S: string): string;

{     }
function OwnCertCfg(const Certificate, SerialNumber, IssuerCN, IssuerOU,
  IssuerO, IssuerL, IssuerS, IssuerC: string): TCertFindCfg;
{      }
function ClientCertCfg(const Certificate, SerialNumber: string;
  ActualSysDate: TDateTime; const SubjectCN: string): TCertFindCfg;

{    DefSysContainer  
DefSysPassword  ,  SysContainerInfo^.Name 
SysContainerInfo^.Password , }
const
  DefSysContainer = 'SYSTEM';
  DefSysPassword = 'SYSTEM';
{  }
type
  TSysContainerInfo = record
    Name: string;     { }
    Password: string; {      }
  end;
  PSysContainerInfo = ^TSysContainerInfo;
{   Value}
procedure InitSysContainerInfo(out Value: TSysContainerInfo);
{        , 
    ,     
  nil}
function SysContainerInfo: PSysContainerInfo;
{       CryptoAPI 
 }
const
  CryptoExternalName = 'CAPIEX.EXE';
  CryptoExternalWndClass = 'CAPIEXCLASS';
  CryptoExternalWndName = 'CAPIEXWINDOW';
  CryptoExternalDefWaitTime = 5 * 60 * 1000;
  AlgProcessDataFunc = 'ALGPROCESSDATA';
  ShutdownFunc = 'SHUTDOWN';

{  }
type
  TCryptoAlgorithmInfo = record
    Provider: TCryptoProviderInfo;
    Algs: TAlgsInfo;
    Flags: TFlagsInfo;
    CertEncodingType: DWORD;
    IsTwoKeysProtect: Boolean;
    IsPrivKeyExpBlocked: Boolean;
    IsUserProtectBlocked: Boolean;
  end;
{    , , }
type
  TCryptoProcessInfo = record
    AlgInfo: TCryptoAlgorithmInfo;    {  }
    SourData: TDataInfo;              { }
    DestData: TDataInfo;              { }
    Container: TContainerInfo;        {}
    PrivateKey: TPrivateKeyInfo;      {     .}
    IsSeparateSignKey: Boolean;       {-  / . }
    SignPrivateKey: TPrivateKeyInfo;  {   }
    PublicKey: TPublicKeyInfo;        {    .}
    IsSeparateImpKey: Boolean;        {    }
    ImpPublicKey: TPublicKeyInfo;     {    .}
    VerifyPublicKey: TPublicKeyInfo;  {    }
    SymmetricKey: TSymmetricKeyInfo;  { }
    CertReq: TCertReqInfo;            {  }
    HashHandle: THCryptHash;          {    .,  0}
    HashKeyHandle: THCryptKey;        {  ,  0}
    PrivKeyPassword: string;          {    }
    SignPrivKeyPassword: string;      {  ..  }
    RandomContainer: string;          {   }
    PrivKey: string;                  {  }
    SignPrivKey: string;              {.   }
    PubKey: string;                   {  }
    PubKeyInfo: string;               {-    }
    SymKey: string;                   { .   ./.}
    Signature: string;                {  /}
    IsMachineKeyset: Boolean;         { }
    IsKeepRandomContainer: Boolean;   {   }
    IsUserProtect: Boolean;           {    }
    IsSignUserProtect: Boolean;       { .  . .}
    IsExpPrivKey: Boolean;            {  }
    IsExpSignPrivKey: Boolean;        {.   }
    IsExpPubKey: Boolean;             {  }
    IsExpPubKeyInfo: Boolean;         {-    }
    IsCertRequest: Boolean;           {   }
    IsProcessing: Boolean;            {   }
    IsProtectSign: Boolean;           {  / }
    IsSignOrVerifyOnly: Boolean;      {    }
    IsImpSymKey: Boolean;             {  }
    IsExpSymKey: Boolean;             {  }
    IsStoringSymmetricKey: Boolean;   {   }
    IsSizedBlocks: Boolean;           {   }
    IsHashUsing: Boolean;             {   }
    IsSignUsing: Boolean;             {   }
    IsStoringSignature: Boolean;      {   }
    IsCaching: Boolean;               { }
    IsExpCertificate: Boolean;        {  }
    ExpCertificate: string;           { }
    UseDefinedCert: Boolean;          {  ,   }
  end;
{   Value (InitCryptoAlgorithmInfo, InitCryptoProcessInfo)}
procedure InitCryptoAlgorithmInfo(out Value: TCryptoAlgorithmInfo);
procedure InitCryptoProcessInfo(out Value: TCryptoProcessInfo);
{      ;  
: 'RSA', 'RSA128', 'RSA40', 'DES', 'GOST', 'MD5RSA', 'SHA1RSA',
'GOST2001';     ,   DefAlg}
function StrToAlg(const S: string): TCryptoAlgorithm;
{   : 'RSA', 'RSA128', 'RSA40', 'DES', 'GOST',
'MD5RSA', 'SHA1RSA', 'GOST2001';     
}
function AlgToStr(Alg: TCryptoAlgorithm): string;
{   CryptoAPI;  ,  caRSA}
function DetectItemAlg(const CryptAlgOID,
  SignAlgOID: string): TCryptoAlgorithm;
{  ;  ,  caRSA}
function DetectCertAlg(CertInfo: PCertInfo): TCryptoAlgorithm;
{  ;  ,  caRSA;  
    ,     , 
caMD5RSA    }
function DetectRequestAlg(RequestInfo: PCertRequestInfo): TCryptoAlgorithm;
{:   ,   , 
,   , ,  , ,
,   ,    }
type
  TCryptoOperType = (cotExpPriv, cotExpPub, cotExpSym, cotCertReq,
    cotSign, cotVerify, cotProtect, cotUnprotect, cotProtectSign,
    cotUnprotectVerify);
{    , ,  }
type
  TAlgProcessInfo = record
    Alg: TCryptoAlgorithm;
    SourData: TDataCfg;
    DestData: TDataCfg;
    Container: TContainerCfg;
    PrivateKey: TPrivateKeyCfg;
    PublicKey: TPublicKeyCfg;
    IsSeparateImpKey: Boolean;
    ImpPublicKey: TPublicKeyCfg;
    SymmetricKey: TSymmetricKeyCfg;
    CertReq: TCertReqInfo;
    PrivKeyPassword: string;
    RandomContainer: string;
    PrivKey: string;
    PubKey: string;
    PubKeyInfo: string;
    SymKey: string;
    Signature: string;
    IsMachineKeyset: Boolean;
    IsUserProtect: Boolean;
    OperType: TCryptoOperType;
    IsCaching: Boolean;
    IsExternal: Boolean;
    LangId: Integer;
    IsExpCertificate: Boolean;
    ExpCertificate: string;
    UseDefinedCert: Boolean;
  end;
{   Value}
procedure InitAlgProcessInfo(out Value: TAlgProcessInfo);
{ TAlgProcessInfo      }
procedure AlgProcessInfoToStrings(const AlgProcessInfo: TAlgProcessInfo;
  Strings: TStrings);
procedure StringsToAlgProcessInfo(Strings: TStrings; var Index: Integer;
  var AlgProcessInfo: TAlgProcessInfo);
{}
const
  {  }
  CAService = 'CertSvc';
  {    }
  RegCAServiceKey = RegMachineServices + CAService + '\';
  {     }
  RegCAConfigurationSubKey = 'Configuration\';
  {  -}
  RegCProKey = 'HKEY_LOCAL_MACHINE\SOFTWARE\Crypto Pro\';

{    CryptoAPI,  }
type
  TCryptoAPICACache = class(TObjectStd)
  private
    FCriticalSection: TCriticalSectionAccess;
    FMainName: string;
  protected
    function GetMainName: string;
    procedure SetMainName(const NewMainName: string);
  public
    constructor Create;
    destructor Destroy; override;
    {}
    { }
    property CriticalSection: TCriticalSectionAccess read FCriticalSection;
    {      }
    property MainName: string read GetMainName write SetMainName;
  end;

{   TCryptoAPI CertGenReq, CertSignMulti, CertVerifyMulti,
CertProtect, CertUnprotect, CertField, CryptVerifyCert, CACryptVerifyCert,
FindCertInStore, AddCertToStore, CertView, CAAcceptRequest, IssueCertificate,
RevokeCertificate }
type
  TCAPICertGenReqMethod = function(Alg: TCryptoAlgorithm; const Subject: TX500;
    UseCertKeyFormat: Boolean; out PublicKeyData, PublicKey: string): string
    of object;
  TCAPICertAcceptMethod = procedure(const CertStr: string;
    IsDeleteRequest: Boolean; StoreFlags: DWORD) of object;
  TCAPICertSignMultiMethod = function(Alg: TCryptoAlgorithm;
    const OwnStoreName, Data: string; const OwnCert: TCertFindCfg; IsFile,
    IsCaching, IsExternal, IsMulti: Boolean): string of object;
  TCAPICertVerifyMultiMethod = function(Alg: TCryptoAlgorithm;
    const OwnStoreName, ClientStoreName, Data, Signature: string;
    const OwnCert, ClientCert: TCertFindCfg; IsOwnCertDefined, IsFile,
    IsCaching, IsExternal, IsMulti: Boolean): string of object;
  TCAPICertProtectMethod = procedure(Alg: TCryptoAlgorithm;
    const SourData: string; var DestData: string; const SymmetricKey: string;
    const OwnCert, ClientCert: TCertFindCfg; IsFile, IsCaching,
    IsExternal: Boolean) of object;
  TCAPICertUnprotectMethod = procedure(Alg: TCryptoAlgorithm;
    const SourData: string; var DestData: string; const SymmetricKey: string;
    const OwnCert, ClientCert: TCertFindCfg; IsFile, IsCaching,
    IsExternal: Boolean) of object;
  TCAPICertFieldMethod = function(const CertStr,
    FieldName: string): string of object;
  TCAPICryptVerifyCertMethod = procedure(const CertStr, CACertStr,
    CACRLStr: string) of object;
  TCAPICACryptVerifyCertMethod = procedure(const CAName,
    CertStr: string) of object;
  TCAPIFindCertInStoreMethod = function(const StoreName: string;
    const CertFindInfo: TCertFindInfo;
    out KeyProvInfo: TSizedBufInfo): string of object;
  TCAPIAddCertToStoreMethod = procedure(const StoreName, CertStr,
    CRLStr: string) of object;
  TCAPICertViewMethod = function(const Certificate, CertFindStoreName: string;
    const CertFindCfg: TCertFindCfg; CertFindWithPrivateKey: Boolean;
    Wnd: HWND; const Title: string): Boolean of object;
  TCAPICAAcceptRequestMethod = function(const CAName,
    Request: string): Integer of object;
  TCAPICAIssueCertificateMethod = function(const CAName: string;
    CertId: Integer): string of object;
  TCAPICARevokeCertificateMethod = procedure(const CAName,
    SerialNumber: string) of object;

type
  TCryptoAPI = class;
  {   Certificate, ,  
  ,    CryptoAPI     CryptoAPI,
        }
  TCAPICertCheckMethod = procedure(CryptoAPI: TCryptoAPI;
    const Certificate: string) of object;
  {}
  { CryptoAPI}
  TCryptoAPI = class(TObjectStd)
  private
    FProc: TFarProc;
    FAdvAPIDLL: TDLLLoadInfo;
    FCryptDLL: TDLLLoadInfo;
    FCryptUIDLL: TDLLLoadInfo;
    FCryptoExternalWaitTime: Integer;
    FCryptoAPICACache: TCryptoAPICACache;
    FRegisterXEnroll: TObjProc;
    FRegisterExternal: TObjProc;
    FExternalInfo: TFuncProcessInfo;
    {}
    FRSAHighProvider: string;
    FCryptContextCache: TList;
    FCryptUserKeyCache: TList;
    FCryptImportedKeyCache: TList;
    FCryptExportedKeyCache: TList;
    FCryptImportedPublicKeyCache: TList;
    FCryptExportedPublicKeyCache: TList;
    {}
    FCryptAcquireContext: TDLLProcInfo;
    FCryptReleaseContext: TDLLProcInfo;
    FCryptGenKey: TDLLProcInfo;
    FCryptDeriveKey: TDLLProcInfo;
    FCryptDestroyKey: TDLLProcInfo;
    FCryptSetKeyParam: TDLLProcInfo;
    FCryptGetKeyParam: TDLLProcInfo;
    FCryptSetHashParam: TDLLProcInfo;
    FCryptGetHashParam: TDLLProcInfo;
    FCryptSetProvParam: TDLLProcInfo;
    FCryptGetProvParam: TDLLProcInfo;
    FCryptGenRandom: TDLLProcInfo;
    FCryptGetUserKey: TDLLProcInfo;
    FCryptExportKey: TDLLProcInfo;
    FCryptImportKey: TDLLProcInfo;
    FCryptEncrypt: TDLLProcInfo;
    FCryptDecrypt: TDLLProcInfo;
    FCryptCreateHash: TDLLProcInfo;
    FCryptHashData: TDLLProcInfo;
    FCryptHashSessionKey: TDLLProcInfo;
    FCryptDestroyHash: TDLLProcInfo;
    FCryptSignHash: TDLLProcInfo;
    FCryptVerifySignature: TDLLProcInfo;
    FCryptSetProvider: TDLLProcInfo;
    {}
    FCryptImportPublicKeyInfo: TDLLProcInfo;
    FCryptExportPublicKeyInfo: TDLLProcInfo;
    FCryptAcquireCertificatePrivateKey: TDLLProcInfo;
    FCertOpenStore: TDLLProcInfo;
    FCertOpenSystemStore: TDLLProcInfo;
    FCertCloseStore: TDLLProcInfo;
    FCertCreateCertificateContext: TDLLProcInfo;
    FCertAddCertificateContextToStore: TDLLProcInfo;
    FCertAddEncodedCertificateToStore: TDLLProcInfo;
    FCertEnumCertificatesInStore: TDLLProcInfo;
    FCertFreeCertificateContext: TDLLProcInfo;
    FCertDeleteCertificateFromStore: TDLLProcInfo;
    FCertCreateCRLContext: TDLLProcInfo;
    FCertFreeCRLContext: TDLLProcInfo;
    FCertGetCertificateContextProperty: TDLLProcInfo;
    FCertSetCertificateContextProperty: TDLLProcInfo;
    FCertEnumCertificateContextProperties: TDLLProcInfo;
    FCertVerifySubjectCertificateContext: TDLLProcInfo;
    FCertVerifyCRLRevocation: TDLLProcInfo;
    FCertAddEncodedCRLToStore: TDLLProcInfo;
    FCryptEnumOIDInfo: TDLLProcInfo;
    FCryptFindOIDInfo: TDLLProcInfo;
    FCryptEncodeObject: TDLLProcInfo;
    FCryptDecodeObject: TDLLProcInfo;
    FCryptSignAndEncodeCertificate: TDLLProcInfo;
    {}
    FCertEnumSystemStore: TDLLProcInfo;
    {}
    FCryptUIDlgSelectCertificate: TDLLProcInfo;
    FCryptUIDlgSelectCertificateFromStore: TDLLProcInfo;
    FCryptUIDlgViewCertificate: TDLLProcInfo;
    FCryptUIDlgViewContext: TDLLProcInfo;
    FCryptUIDlgCertMgr: TDLLProcInfo;
    {}
    FFields: TStringList; {CryptEncodeSMIMECompatibilities,
      CryptEncodeCertExtensions, EncodeX500, CertNameItemField, CertNameItem}
    FValues: TStringList; {CryptEncodeSMIMECompatibilities, EncodeX500,
      CertNameItemField, CertNameItem}
    FDatas: TStringList; {EncodeNameItemFields}
    FResults: TStringList; {EncodeNameItemFields, CertNameItem}
    FWides: TWideStrings; {CryptEncodeCertExtensions}
    {}
    FCProSID: string;
    FCProVersion: TNullInt;
    FCProAllowProvSubst: Boolean;
    FCProProvSubst: string;
    FOIDPtrs: TList;
    FOIDs: TIndexedStrings;
    FOIDNames: TIndexedStrings;
    FAlgsExChecked: Boolean;
    FAlgsExSupported: Boolean;
    FProviderTypes: TIndexedList;
    FProviderTypesInfo: TCryptoProviderTypesInfo;
    FProviderNames: TIndexedStrings;
    FProviderNameTypes: TIndexedList;
    FProviderNamesInfo: TCryptoProviderNamesInfo;
    FProviderAlgs: TObjList; {TIndexedList}
    FProviderAlgsInfos: TObjList; {TCryptoProviderAlgsInfo}
    FProviderDefAlgsInfo: TCryptoProviderDefAlgsInfo;
    {}
    FDefKeySpec: DWORD;
    FDefMyStoreName: string;
    FDefContainer: string;
    FDefRequestStoreName: string;
    FNotUserProtect: Boolean;
    FSimpleExport: Boolean;
    FKeyInitVector: string;
    FNoBlocksHashing: Boolean;
    FCertFindSerialAsThumbprint: Boolean;
    FExternalCert: string;
    FFQDNs: string;
    FRequestGenKey: Boolean;
    FAdditionalGostCertUsages: string;
    FClientCerts: TCertFindsCfg;
    FClientCertsInfo: TCertFindsInfo;
    FClientSymmetricKey: string;
    FNotAllowCombinedKeyCaching: Boolean;
    {}
    procedure DlgException(Sender, Error: TObject);
    function DlgSignCertificateView(Sender: TObject; var StoreName,
      Certificate, SerialNumber: string; var ActualSysDate: TDateTime;
      var Issuer, Subject: string; IsExtractName, IsSelect: Boolean): TNullStr;
    function DlgVerifyCertificateView(Sender: TObject; var StoreName,
      Certificate, SerialNumber: string; var ActualSysDate: TDateTime;
      var Issuer, Subject: string; IsExtractName, IsSelect: Boolean): TNullStr;
    function DlgCertificateView(Sender: TObject; var StoreName,
      Certificate, SerialNumber: string; var ActualSysDate: TDateTime;
      var Issuer, Subject: string; IsExtractName, IsSelect,
      IsSign: Boolean): TNullStr;
  protected
    FLastError: Integer;
    {}
    function LoadAdvAPIProc(const ProcName: string;
      var DLLProcInfo: TDLLProcInfo): TFarProc;
    function LoadCryptProc(const ProcName: string;
      var DLLProcInfo: TDLLProcInfo): TFarProc;
    function LoadCryptUIProc(const ProcName: string;
      var DLLProcInfo: TDLLProcInfo): TFarProc;
    {}
    procedure RegisterXEnroll;
    procedure RegisterExternal;
    function GetExternalInfo: PFuncProcessInfo;
    {}
    procedure CachedReleaseAllContexts;
    procedure CachedDestroyAllKeys(ProvHandle: THCryptProv);
    {}
    function GetCProSID: string;
    function GetCProVersion: Integer;
    function GetOIDs: TIndexedStrings;
    function GetOIDNames: TIndexedStrings;
    function GetProviderTypes: TIndexedList;
    function GetProviderTypesInfo: TCryptoProviderTypesInfo;
    function GetProviderNames: TIndexedStrings;
    function GetProviderNameTypes: TIndexedList;
    function GetProviderNamesInfo: TCryptoProviderNamesInfo;
    function GetProviderAlgs(ProviderIndex: Integer): TIndexedList;
    function GetProviderAlgsInfos(ProviderIndex: Integer):
      TCryptoProviderAlgsInfo;
    function GetProviderDefAlgInfo(ProviderIndex: Integer):
      TCryptoProviderDefAlgInfo;
    function GetCAValidityPeriod: TPeriod;
    procedure SetCAValidityPeriod(const NewCAValidityPeriod: TPeriod);
    function GetClientCerts: TCertFindsCfg;
    function GetClientCertsInfo: TCertFindsInfo;
  public
    {  (     XEnroll.dll)}
    constructor Create;
    destructor Destroy; override;
    {}
    { }
    procedure ClearCache;
    {}
    {    XEnroll.dll,    
     ,  RegisterXEnroll }
    procedure IncludeXEnrollDll;
    {     CAPIEx.exe,    
     ,  RegisterExternal }
    procedure IncludeExternalExe;
    {    XEnroll.dll    CAPIEx.exe,
         ,  RegisterXEnroll 
    RegisterExternal }
    procedure IncludeXEnrollDllExternalExe;
    {}
    {  , ,    
    ,  MakeDefault   (    , 
     )       
    (CProInstallRegistryStorage),       -
     (CProSetRegistryStorage);   ,   
       (CProFixRegistryStorage);  
    Container   (CProSetDefaultContainer);  ,  
        -,
     IsMachineKeyset = True    ,   
     (CProContainersRegistryKey);    
      (CProExportContainer);     S
    (CProImportContainer)  -,  IsMachineKeyset = True -  
     ,    }
    function CProInstallRegistryStorage(IsMachineKeyset,
      MakeDefault: Boolean): Boolean;
    procedure CProSetRegistryStorage(IsMachineKeyset: Boolean);
    procedure CProFixRegistryStorage(IsMachineKeyset: Boolean);
    procedure CProSetDefaultContainer(const Container: string;
      IsMachineKeyset: Boolean);
    function CProContainersRegistryKey(IsMachineKeyset: Boolean): string;
    function CProExportContainer(const Container: string;
      IsMachineKeyset: Boolean): string;
    procedure CProImportContainer(const Container, S: string;
      IsMachineKeyset: Boolean);
    {}
    {   CryptoAPI}
    function CryptAcquireContext(const Container, Provider: string;
      ProvType, Flags: DWORD): THCryptProv;
    procedure CryptReleaseContext(ProvHandle: THCryptProv; Flags: DWORD);
    function CryptGenKey(ProvHandle: THCryptProv; AlgId: TAlgId;
      Flags: DWORD): THCryptKey;
    function CryptDeriveKey(ProvHandle: THCryptProv; AlgId: TAlgId;
      BaseData: THCryptHash; Flags: DWORD): THCryptKey;
    procedure CryptDestroyKey(KeyHandle: THCryptKey);
    function CryptSetKeyParam(KeyHandle: THCryptKey;
      Param: DWORD; const Data; Flags: DWORD; IgnoreErrors: Boolean): Boolean;
    function CryptGetKeyParam(KeyHandle: THCryptKey;
      Param, Flags: DWORD; PredictableLen: Integer): string;
    procedure CryptSetHashParam(HashHandle: THCryptHash;
      Param: DWORD; const Data; Flags: DWORD);
    function CryptGetHashParam(HashHandle: THCryptHash;
      Param, Flags: DWORD; PredictableLen: Integer): string;
    procedure CryptSetProvParam(ProvHandle: THCryptProv;
      Param: DWORD; const Data; Flags: DWORD);
    function CryptGetProvParam(ProvHandle: THCryptProv;
      Param, Flags: DWORD; out NoMoreItems: Boolean): string;
    procedure CryptGenRandom(ProvHandle: THCryptProv; DataLen: DWORD;
      var Data);
    function CryptGetUserKey(ProvHandle: THCryptProv;
      KeySpec: DWORD): THCryptKey;
    function CryptExportKey(KeyHandle, ExpKeyHandle: THCryptKey;
      KeyBlobType, Flags: DWORD): string;
    function CryptImportKey(ProvHandle: THCryptProv;
      const Key: string; ImpKeyHandle: THCryptKey; Flags: DWORD;
      IsProtectedPrivateKey: Boolean): THCryptKey;
    procedure CryptEncrypt(KeyHandle: THCryptKey;
      HashHandle: THCryptHash; IsFinal: Boolean; Flags: DWORD;
      var Data; var DataLen: DWORD; BufLen: DWORD;
      out IsBufSmall: Boolean; ErrorIfBufSmall: Boolean);
    procedure CryptDecrypt(KeyHandle: THCryptKey;
      HashHandle: THCryptHash; IsFinal: Boolean; Flags: DWORD;
      var Data; var DataLen: DWORD);
    function CryptCreateHash(ProvHandle: THCryptProv; AlgId: TAlgId;
      KeyHandle: THCryptKey; Flags: DWORD): THCryptHash;
    procedure CryptHashData(HashHandle: THCryptHash; const Data;
      DataLen: Integer; Flags: DWORD);
    procedure CryptHashSessionKey(HashHandle: THCryptHash;
      KeyHandle: THCryptKey; Flags: DWORD);
    procedure CryptDestroyHash(HashHandle: THCryptHash);
    function CryptSignHash(HashHandle: THCryptHash;
      KeySpec: DWORD; Flags: DWORD): string;
    procedure CryptVerifySignature(HashHandle: THCryptHash;
      const Signature: string; PubKeyHandle: THCryptKey; Flags: DWORD);
    procedure CryptSetProvider(const ProvName: string; ProvType: DWORD);
    {}
    {   CryptoAPI    }
    function CryptImportPublicKeyInfo(ProvHandle: THCryptProv;
      CertEncodingType: DWORD;
      const PublicKeyInfo: TCertPublicKeyInfo): THCryptKey;
    function CryptExportPublicKeyInfo(ProvHandle: THCryptProv; KeySpec,
      CertEncodingType: DWORD): TSizedBufInfo; {CERT_PUBLIC_KEY_INFO}
    function CryptAcquireCertificatePrivateKey(
      CertContextPtr: PCCertContext; Flags: DWORD;
      var KeySpec: DWORD; var IsCallerFreeProv: BOOL): THCryptProv;
    function CertOpenStore(StoreProvider: PChar;
      MsgAndCertEncodingType: DWORD; ProvHandle: THCryptProv;
      Flags: DWORD; const Para): THCertStore;
    function CertOpenSystemStore(ProvHandle: THCryptProv;
      const StoreName: string): THCertStore;
    procedure CertCloseStore(CertStoreHandle: THCertStore; Flags: DWORD);
    function CertCreateCertificateContext(CertEncodingType: DWORD;
      const CertStr: string): PCCertContext;
    procedure CertAddCertificateContextToStore(CertStoreHandle: THCertStore;
      CertContext: PCCertContext; AddDisposition: DWORD;
      CertContextPtr: PPCCertContext);
    procedure CertAddEncodedCertificateToStore(
      CertStoreHandle: THCertStore; CertEncodingType: DWORD;
      const CertEncodedStr: string; AddDisposition: DWORD;
      CertContextPtr: PPCCertContext);
    function CertEnumCertificatesInStore(CertStoreHandle: THCertStore;
      PrevCertContext: PCCertContext): PCCertContext;
    procedure CertFreeCertificateContext(CertContext: PCCertContext);
    procedure CertDeleteCertificateFromStore(CertContext: PCCertContext);
    function CertCreateCRLContext(CertEncodingType: DWORD;
      const CRLStr: string): PCCRLContext;
    procedure CertFreeCRLContext(CrlContext: PCCRLContext);
    function CertGetCertificateContextProperty(
      CertContext: PCCertContext; PropId: DWORD): TSizedBufInfo;
    procedure CertSetCertificateContextProperty(
      CertContext: PCCertContext; PropId, Flags: DWORD; Data: Pointer);
    function CertEnumCertificateContextProperties(
      CertContext: PCCertContext; PropId: DWORD): DWORD;
    procedure CertVerifySubjectCertificateContext(
      Subject: PCCertContext; Issuer: PCCertContext; var Flags: DWORD);
    procedure CertVerifyCRLRevocation(CertEncodingType: DWORD;
      CertId: PCertInfo; CrlInfoCnt: DWORD; CrlInfo: PPCRLInfo);
    procedure CertAddEncodedCRLToStore(
      CertStoreHandle: THCertStore; CertEncodingType: DWORD;
      const CRLEncodedStr: string; AddDisposition: DWORD;
      CRLContextPtr: PPCCRLContext);
    function CryptEnumOIDInfo(GroupId, Flags: DWORD; Arg: Pointer;
      EnumOIDInfoFunc: TPFnCryptEnumOIDInfoFunc): Boolean;
    function CryptFindOIDInfo(KeyType: DWORD; Key: Pointer; GroupId: DWORD;
      ErrorIfNotFound: Boolean): PCCryptOIDInfo;
    function CryptEncodeObject(CertEncodingType: DWORD;
      StructType: PChar; BufPtr: Pointer): string;
    function CryptDecodeObject(CertEncodingType: DWORD;
      StructType: PChar; const EncodedStr: string;
      Flags: DWORD): TSizedBufInfo;
    function CryptSignAndEncodeCertificate(ProvHandle: THCryptProv;
      KeySpec, CertEncodingType: DWORD; StructType: PChar; StructInfo: Pointer;
      SignatureAlgorithm: PCryptAlgorithmIdentifier;
      HashAuxInfo: Pointer): string;
    procedure CertEnumSystemStore(Flags: DWORD;
      SystemStoreLocationPara: PCertSystemStoreRelocatePara;
      EnumFuncArg: Pointer; EnumFunc: TCertEnumSystemStoreCallbackFunc);
    function CryptUIDlgSelectCertificate(var SelectCert:
      TSelectCert): PCCertContext;
    function CryptUIDlgSelectCertificateFromStore(CertStore: THCertStore;
      Wnd: HWND; const Title, DisplayString: string; DontUseColumn,
      Flags: DWORD): PCCertContext;
    function CryptUIDlgViewCertificate(var ViewCert: TViewCert): Boolean;
    function CryptUIDlgViewContext(ContextType: DWORD; Context: Pointer;
      Wnd: HWND; const Title: WideString; Flags: DWORD): Boolean;
    function CryptUIDlgCertMgr(const CryptUICertMgr:
      TCryptUICertMgrStruct): Boolean;
    {}
    {   CryptoAPI,  ;
    ,           , 
       ;   
             /;
             
     ;      
       ,     
        }
    function CachedAcquireContext(const Container, Provider: string;
      ProvType, Flags: DWORD; IsCaching: Boolean): THCryptProv;
    procedure CachedReleaseContext(ProvHandle: THCryptProv;
      Flags: DWORD; IsCaching: Boolean);
    function CachedGenKey(ProvHandle: THCryptProv; AlgId: TAlgId;
      Flags: DWORD; IsCaching: Boolean): THCryptKey;
    function CachedGetUserKey(ProvHandle: THCryptProv;
      KeySpec: DWORD; IsCaching: Boolean): THCryptKey;
    procedure CachedDestroyKey(KeyHandle: THCryptKey; IsCaching: Boolean);
    function CachedImportKey(ProvHandle: THCryptProv;
      const Key: string; ImpKeyHandle: THCryptKey; Flags: DWORD;
      IsProtectedPrivateKey, IsCaching: Boolean): THCryptKey;
    function CachedExportKey(ProvHandle: THCryptProv;
      KeyHandle, ExpKeyHandle: THCryptKey; KeyBlobType, Flags: DWORD;
      IsCaching: Boolean): string;
    function CachedImportPublicKeyInfo(ProvHandle: THCryptProv;
      CertEncodingType: DWORD; const PublicKeyInfo: TCertPublicKeyInfo;
      IsCaching: Boolean): THCryptKey;
    function CachedExportPublicKeyInfo(ProvHandle: THCryptProv; KeySpec,
      CertEncodingType: DWORD; IsCaching: Boolean): TSizedBufInfo;
    {}
    {   ;  Provider  Container - 
    ,    ,   
    ;         
            
      ;  CertUsage -  ,    
     ; RequestStoreFlags -  (,
    CERT_SYSTEM_STORE_CURRENT_USER, CERT_SYSTEM_STORE_LOCAL_MACHINE),
     ,    0,  IsReturnPublicKey = True
     PublicKeyData   ,  PublicKeyInfo 
          PublicKeyInfoToStr;  
      ExternalCert  ,   ,
       ,     
    }
    function CertRequest(var Provider, Container: string;
      ProvType: DWORD; ProvMode: TCryptoProviderMode; KeySpec, HashAlgId,
      AcquireFlags, GenKeyFlags: DWORD; IsUseExistingKeys,
      IsDeleteRequest: Boolean; const Subject: TX500; CertUsage: string;
      RequestStoreFlags: DWORD; IsReturnPublicKey: Boolean;
      out PublicKeyData, PublicKeyInfo: string): string;
    { CertRequest,  xenroll.dll}
    function CertRequestXEnroll(var Provider, Container: string;
      ProvType: DWORD; ProvMode: TCryptoProviderMode; KeySpec, HashAlgId,
      AcquireFlags, GenKeyFlags: DWORD; IsUseExistingKeys,
      IsDeleteRequest: Boolean; const Subject: TX500; CertUsage: string;
      RequestStoreFlags: DWORD; IsReturnPublicKey: Boolean;
      out PublicKeyData, PublicKeyInfo: string): string;
    {      ; 
    PrivateKey  Password  ,     
        KeySpec; AlgId   
       ;    CertRequest}
    function CertRequestByKey(var Provider, Container: string;
      const PrivateKey, Password: string; ProvType: DWORD;
      ProvMode: TCryptoProviderMode; KeySpec: DWORD; AlgId, HashAlgId: TAlgId;
      ImportFlags: DWORD; IsDeleteKeys, IsDeleteRequest: Boolean;
      const Subject: TX500; CertUsage: string; RequestStoreFlags: DWORD;
      ReturnPublicKey: Boolean; out PublicKeyData,
      PublicKeyInfo: string): string;
    { ; StoreFlags -  (,
    CERT_SYSTEM_STORE_CURRENT_USER, CERT_SYSTEM_STORE_LOCAL_MACHINE);
     0 -  ,   CryptKeyProvInfo  
        ,      
     IsDeleteRequest  True    }
    procedure CertAccept(const CertStr: string; IsDeleteRequest: Boolean;
      StoreFlags: DWORD; CryptKeyProvInfo: PCryptKeyProvInfo);
    { CertAccept,   xenroll.dll}
    procedure CertAcceptXEnroll(const CertStr: string;
      IsDeleteRequest: Boolean; StoreFlags: DWORD);
    {}
    {     }
    procedure CARetrieveNames(CANames: TStrings);
    {    }
    function CAMainName: string;
    {       
      }
    function CALocalName: string;
    {    ; CAName - 
     ;    ,   
      }
    function CACertificate(const CAName: string): string;
    {     ;  
    CAName  CAMainName;  IsPublish    
        ExpirationSysDate}
    function CACRL(const CAName: string; IsPublish: Boolean;
      ExpirationSysDate: TDateTime): string;
    {   ;   CAName  CAMainName;
      }
    function CAAcceptRequest(const CAName, Request: string): Integer;
    {   ;   CAName 
    CAMainName; ..      , 
     ErrorIfXXXX ,      
     }
    function CARetrieveCertificate(const CAName: string;
      CertId: Integer; Base64Encoded, ErrorIfIncomplete, ErrorIfDenied,
      ErrorIfIssued, ErrorIfUnderSubmission, ErrorIfUnknownState: Boolean;
      var CertState: Integer): string;
    { ;   CAName  CAMainName; CertId -
     , , ,  CAAcceptRequest}
    function CAIssueCertificate(const CAName: string; CertId: Integer): string;
    { }
    procedure CARevokeCertificate(const CAName, SerialNumber: string);
    { ;   CAName  CAMainName; 
     ,       ,   
    ,   IsFound,  False;  
        , .. ,    
      ,     }
    procedure CAVerifyCert(const CAName, CertStr: string;
      out IsFound: Boolean);
    {     CryptoAPI  Certification Authority}
    procedure CACryptVerifyCert(const CAName, CertStr: string);
    {}
    { CertCreateCertificateContext, CertAddEncodedCertificateToStore,
    CertCreateCRLContext, CertAddEncodedCRLToStore,   
     Base64-   Base64  ,   ,
      ,   ,  CertStr, CRLStr
           
    ,       }
    function CodedCertCreateCertificateContext(
      CertEncodingType: DWORD; var CertStr: string): PCCertContext;
    procedure CodedCertAddEncodedCertificateToStore(
      CertStoreHandle: THCertStore; CertEncodingType: DWORD;
      var CertStr: string; AddDisposition: DWORD;
      CertContextPtr: PPCCertContext);
    function CodedCertCreateCRLContext(CertEncodingType: DWORD;
      var CRLStr: string): PCCRLContext;
    procedure CodedCertAddEncodedCRLToStore(
      CertStoreHandle: THCertStore; CertEncodingType: DWORD;
      var CRLStr: string; AddDisposition: DWORD;
      CRLContextPtr: PPCCRLContext);
    {}
    {    CertStoreHandle,  
     Wnd,   Title,      
    DisplayString,    DontUseColumn, ,
    CRYPTUI_SELECT_ISSUEDBY_COLUMN or CRYPTUI_SELECT_INTENDEDUSE_COLUMN or
    CRYPTUI_SELECT_FRIENDLYNAME_COLUMN or CRYPTUI_SELECT_LOCATION_COLUMN or
    CRYPTUI_SELECT_EXPIRATION_COLUMN,  Flags,  
       nil,     (SelectCertificate);
        CertContext,  
     Wnd,   Title,  Flags,     
    OK  True,  False (ViewCertificate);    
    ,    Wnd,   Title,
     Flags, OID   InitUsageOID,    
         False,    True,
       CertStoreHandle   StoreName,
     nil,  CertStr     
    ,    (CertificateManager)}
    function SelectCertificate(CertStoreHandle: THCertStore; Wnd: HWND;
      const Title, DisplayString: string; DontUseColumn, Flags: DWORD;
      const StoreName: string; out CertStr: string): PCCertContext;
    function ViewCertificate(CertContext: PCCertContext; Wnd: HWND;
      const Title: string; Flags: DWORD): Boolean;
    function CertificateManager(Wnd: HWND; const Title: string; Flags: DWORD;
      const InitUsageOID: string): Boolean;
    {}
    {    ,   
     ProvHandle,  IsFirst = True    
    ,    NoMoreItems  False , 
      ,     ,   
           ,
       CryptoAPI,    Internet Explorer 4
     ,        }
    function EnumProvAlg(ProvHandle: THCryptProv; IsFirst: Boolean;
      out NoMoreItems: Boolean): TCryptoProviderAlgInfo;
    {  ProviderAlgsInfo,   nil,  ,
      Provider   ProvType,  
    Provider   ,      
     ,       
        }
    function EnumProvAlgs(const Provider: string; ProvType: DWORD;
      ProviderAlgsInfo: TCryptoProviderAlgsInfo): TCryptoProviderDefAlgInfo;
    {  ProviderCotainers  , 
     Provider   ProvType,   
    }
    function EnumProvContainers(const Provider: string; ProvType: DWORD;
      ProviderContainers: TStrings): Integer;
    {  Provider  ProvType    Container
       ,   NotUnique  True
       }
    function ProvContainerToUnique(const Provider: string;
      ProvType: DWORD; const Container: string; NotUnique: Boolean): string;
    {  OIDInfoList   PCCRYPT_OID_INFO 
       OID   GroupId, ,
    CRYPT_ENCRYPT_ALG_OID_GROUP_ID, 0   ,   
        CryptoAPI}
    procedure EnumOIDInfo(GroupId: DWORD; OIDInfoList: TList);
    {     OID   GroupId, ,
    CRYPT_ENCRYPT_ALG_OID_GROUP_ID, 0   , OID  
     ,   ,    Name,   ,
       AlgId,       PubKeyAlgId 
     ,  }
    function FindOIDInfo(GroupId: DWORD; const OID, Name: string; AlgId,
      PubKeyAlgId: TAlgId): TNullCryptOIDInfo;
    { OID      AlgOIDToStr,  
        OIDs}
    function OIDToStr(const OID: string): string;
    {   HashAlgId   OID ,
       'MD2', 'MD5', 'SHA1'   ,
     OIDOnly   OID, PubAlgId   
         0,     
       PubAltAlgId   0}
    function HashAlgToOIDOrName(HashAlgId, PubAlgId, PubAltAlgId: TAlgId;
      OIDOnly: Boolean): string;
    {  OID    , 
      ,  AlgOIDToHashAlgId}
    function OIDToHashAlgId(const OID: string): TAlgId;
    {      OID  , 
       }
    function OIDToExchAlgId(const OID: string): TAlgId;
    {     OID  , 
       }
    function OIDToSignAlgId(const OID: string): TAlgId;
    {   AlgId   ,  Provider 
     ,      ,
        ,    
    ,     ,  
     0     provider}
    function AlgIdToProvType(AlgId: TAlgId; out Provider: string): DWORD;
    {  OID    ,  
      ,  AlgOIDToProvType}
    function OIDToProvType(const OID: string): DWORD;
    {   szOID_KEY_USAGE    
    KeySpec, , AT_KEYEXCHANGE  AT_SIGNATURE,  
    CertEncodingType}
    function CryptEncodeKeyUsage(CertEncodingType, KeySpec: DWORD): string;
    {   szOID_ENHANCED_KEY_USAGE 
       UsageOID, ,
    szOID_PKIX_KP_CLIENT_AUTH,   CertEncodingType,
    UsageOIDs,   nil,    
     ,    ,  UsageOID  
    ,    }
    function CryptEncodeEnchancedKeyUsage(CertEncodingType: DWORD;
      const UsageOID: string; UsageOIDs: TStrings): string;
    {   TCertAltNameInfo  
    CertAltNameInfo   AltNameChoice, CertAltNameInfos,   nil,
       ,    CertAltNameInfo
      ,     }
    function CryptEncodeAlternateNameWideString(CertEncodingType,
      AltNameChoice: DWORD; const CertAltNameInfo: WideString;
      CertAltNameInfos: TWideStrings): string;
    {  SMIME,  szOID_RSA_SMIMECapabilities 
        Provider,  ProvType,   
    ,       , KeySpec
      ,   CertEncodingType,   
     ,  KeySpec = AT_SIGNATURE   
    PROV_GOST_DH, PROV_GOST_94_DH, PROV_GOST_2001_DH    
    }
    function CryptEncodeSMIMECompatibilities(CertEncodingType: DWORD;
      const Provider: string; ProvType, KeySpec: DWORD): string;
    {   szOID_CERT_EXTENSIONS 
    ,  IsRequest = True,      Provider, 
    ProvType,    ,     
     , KeySpec     CryptEncodeKeyUsage, 
    szOID_KEY_USAGE  CryptEncodeSMIMECompatibilities, 
    KeySpec = AT_SIGNATURE    PROV_GOST_DH, PROV_GOST_94_DH,
    PROV_GOST_2001_DH  szOID_RSA_SMIMECapabilities ,
    UsageOIDs       
       CryptEncodeEnchancedKeyUsage, 
    ,    szOID_ENHANCED_KEY_USAGE ,
      CertEncodingType, FQDNs     
     ,  }
    function CryptEncodeCertExtensions(CertEncodingType: DWORD;
      const Provider: string; ProvType, KeySpec: DWORD;
      const UsageOIDs, FQDNs: string; IsRequest: Boolean): string;
    {    Windows   szOID_OS_VERSION,
      CertEncodingType}
    function CryptEncodeOSVersion(CertEncodingType: DWORD): string;
    {      Provider  
    szOID_ENROLLMENT_CSP_PROVIDER,   KeySpec, ,
    AT_KEYEXCHANGE  AT_SIGNATURE,   CertEncodingType}
    function CryptEncodeEnrollmentCSPProvider(CertEncodingType, KeySpec: DWORD;
      const Provider: string): string;
    {     ,    -
    CERT_REQUEST_INFO,   ,   Base64,  Base64 
      ,   ,   
     }
    function CryptDecodeRequest(const RequestStr: string): TSizedBufInfo;
    {    }
    function GetAlgInfo(Alg: TCryptoAlgorithm): TCryptoAlgorithmInfo;
    {     }
    function ProvTypeToName(ProvType: DWORD;
      ProvMode: TCryptoProviderMode): string;
    {  (   
    );  MachineStoreInit   ;
     LeaveContainer   ;  NotCreateContainer
      ,   ; GenExchangeKeys 
    GenSignKeys -   AT_KEYEXCHANGE  AT_SIGNATURE
    }
    procedure ProviderInit(ProvType: DWORD; ProvMode: TCryptoProviderMode;
      const Provider, Container: string; MachineStoreInit, LeaveContainer,
      NotCreateContainer, GenExchangeKeys, GenSignKeys, IsSignData: Boolean);
    {  ; Len    ;
      ,  ,   -  }
    function GetKeyParam(KeyHandle: THCryptKey; Param, Flags: DWORD;
      Len: Integer): string;
    {  ; Len    ;
      ,  ,   -  }
    function GetHashParam(HashHandle: THCryptKey; Param, Flags: DWORD;
      Len: Integer): string;
    {      ,   
     ()  ;    InitVector
           
    }
    procedure SetInitVector(KeyHandle: THCryptKey; const InitVector: string);
    {  ;      ,  
         }
    function GetHashValue(HashHandle: THCryptHash; Flags: DWORD): string;
    {  }
    procedure SetHashValue(HashHandle: THCryptHash; const HashValue: string;
      Flags: DWORD);
    {    ;     
    BaseBlockLen (        ),
          MaxBlockLen}
    function GetProtectBlockLen(KeyHandle: THCryptKey;
      BaseBlockLen, MaxBlockLen: Integer): Integer;
    {  CryptoAPI    
      }
    function AcquireContext(const Provider: string;
      ProvType, Flags: DWORD; out Container: string): THCryptProv;
    {   }
    function DeriveKeyByPassword(ProvHandle: THCryptProv;
      DeriveAlgId, HashAlgId: TAlgId; HashKeyHandle: THCryptKey;
      DeriveFlags, HashFlags, HashingFlags: DWORD;
      const Password: string): THCryptKey;
    {  }
    function ExportPrivateKey(ProvHandle: THCryptProv; ExchKeys: THCryptKey;
      const Password: string; DeriveAlgId, HashAlgId: TAlgId;
      HashKeyHandle: THCryptKey; DeriveFlags, HashFlags, HashingFlags,
      ExportFlags: DWORD): string;
    {  }
    function ImportPrivateKey(ProvHandle: THCryptProv; const Key,
      Password: string; DeriveAlgId, HashAlgId: TAlgId;
      HashKeyHandle: THCryptKey; DeriveFlags, HashFlags, HashingFlags,
      ImportFlags: DWORD): THCryptKey;
    {  - ; IsFinal = True ,   
        )}
    function CryptEncryptStr(KeyHandle: THCryptKey;
      IsFinal: Boolean; const DataStr: string): string;
    { ; IsFinal = True ,    
       )}
    function CryptDecryptStr(KeyHandle: THCryptKey;
      IsFinal: Boolean; const DataStr: string): string;
    {  }
    procedure HashData(const Data: TDataInfo; HashHandle: THCryptHash;
      HashingFlags: DWORD);
    { }
    function SignData(ProvHandle: THCryptProv; const Data: TDataInfo;
      SignKeySpec, HashAlgId: TAlgId; HashKeyHandle: THCryptKey; HashFlags,
      HashingFlags, SignFlags: DWORD): string;
    {  }
    procedure VerifyData(ProvHandle: THCryptProv; const Data: TDataInfo;
      const Signature: string; PubKeyHandle: THCryptKey; HashAlgId: TAlgId;
      HashKeyHandle: THCryptKey; HashFlags, HashingFlags, VerifyFlags: DWORD);
    {    ;  HashHandle  ,  
     ;  IsSizedBlocks = True   
           ,   
          ,   
     ;  ,     
      - ;  IsApplyHash = True   ,
     IsSizedBlocks = True      
    ;    ,     ; 
    IsSigning = True   ( SignKeySpec  SignFlags
        ),   IsSaveSignature = True 
         ,  IsSizedBlocks = True;  ,
              
       HashHandle  ,    
       ( HashAlgId, HashKeyHandle,
    HashFlags     ; ProvHandle -  
        )}
    function ProtectData(ProvHandle: THCryptProv; const SourData: TDataInfo;
      var DestData: TDataInfo; SymKeyHandle: THCryptKey;
      HashHandle: THCryptHash; HashAlgId: TAlgId; HashKeyHandle: THCryptKey;
      SignKeySpec: DWORD; HashFlags, HashingFlags, HashParamFlags,
      SignFlags: DWORD; IsSizedBlocks, IsApplyHash, IsSigning,
      IsSaveSignature: Boolean): string;
    {    ,   
    ProtectData,      ;   
     ,  HashHandle  ,     
    ;   IsSigned = True  IsLoadSignature = True 
      ,  -   Signature; HashAlgId, HashKeyHandle,
    HashFlags    , PubKeyHandle, Signature, VerifyFlags - 
     , ProvHandle -      ; 
         ECryptoAPIHashCheckError;
       - ECryptoAPIVerifyError}
    procedure UnprotectData(ProvHandle: THCryptProv; const SourData: TDataInfo;
      var DestData: TDataInfo; SymKeyHandle: THCryptKey;
      HashHandle: THCryptHash; HashAlgId: TAlgId; HashKeyHandle,
      PubKeyHandle: THCryptKey; const Signature: string; HashFlags,
      HashingFlags, HashParamFlags, VerifyFlags: DWORD; IsSizedBlocks,
      IsCheckHash, IsSigned, IsLoadSignature: Boolean);
    {    ; RandomContainer -  
            
    (     ), IsExpCertificate 
         ,   
       ExpCertificate}
    function AccessContainer(const Provider: TCryptoProviderInfo;
      const Container: TContainerInfo; AcquireFlags: DWORD;
      out RandomContainer: string; IsMachineKeyset, IsCaching,
      IsExpCertificate: Boolean; out ExpCertificate: string): THCryptProv;
    {    ; KeySpec     
    ; DeriveAlgId, HashAlgId, HashKeyHandle, DeriveFlags, HashFlags,
    HashingFlags, ImportFlags -  ; GenKeyFlags, IsUserProtect - 
    }
    function AccessPrivateKey(ProvHandle: THCryptProv;
      const PrivateKey: TPrivateKeyInfo; KeySpec: DWORD; DeriveAlgId,
      HashAlgId: TAlgId; HashKeyHandle: THCryptKey; GenKeyFlags, DeriveFlags,
      HashFlags, HashingFlags, ImportFlags: DWORD; IsUserProtect,
      IsCaching: Boolean): THCryptKey;
    {    ; KeySpec     
     (  UserKeyHandle,    , 
      ); CertEncodingType -    
     ; ImportFlags -  ;  ImpKeyHandle <> 0
         ;  IsExpPubKeyInfo = True
          PubKeyInfo  
    PublicKeyInfoToStr, IsMachineKeyset    
     , UseDefinedCert     ,
       ,   ClientCertsUsed   
        ClientCertsInfo}
    function AccessPublicKey(ProvType: DWORD; ProvHandle: THCryptProv;
      const PublicKey: TPublicKeyInfo; KeySpec: DWORD;
      ImpKeyHandle, UserKeyHandle: THCryptKey; ImportFlags,
      CertEncodingType: DWORD; IsCaching, IsExpPubKeyInfo: Boolean;
      out PubKeyInfo: string; IsMachineKeyset,
      UseDefinedCert: Boolean; ClientCertsUsed: PBooleanStd): THCryptKey;
    {    ; ImpKeyHandle, ImportFlags
        SymmetricKeyInfo.Key; DeriveAlgId, HashAlgId,
    HashKeyHandle, DeriveFlags, HashFlags, HashingFlags -   
    ; AlgId, GenKeyFlags -  }
    function AccessSymmetricKey(ProvType: DWORD; ProvHandle: THCryptProv;
      const SymmetricKey: TSymmetricKeyInfo; ImpKeyHandle: THCryptKey; AlgId,
      DeriveAlgId, HashAlgId: TAlgId; HashKeyHandle: THCryptKey; ImportFlags,
      GenKeyFlags, DeriveFlags, HashFlags, HashingFlags: DWORD;
      IsCaching: Boolean): THCryptKey;
    {  , , }
    procedure ProcessData(var Info: TCryptoProcessInfo);
    {  , ,   ;
     Info.IsExternal   }
    procedure AlgProcessData(var Info: TAlgProcessInfo);
    {  }
    procedure ShutdownExternal;
    {}
    {  X500 Fields    Values, 
      X509_NAME, IsAscendingOrder  
      , CertEncodingType   
    (EncodeNameItemFields);   X500,  
     X509_NAME IsAscendingOrder     ,
      X500, CertEncodingType    (EncodeX500)}
    function EncodeNameItemFields(CertEncodingType: DWORD;
      Fields, Values: TStrings; IsAscendingOrder: Boolean): string;
    function EncodeX500(CertEncodingType: DWORD; const X500: TX500;
      IsAscendingOrder: Boolean): string;
    {   , IsAscendingOrder - 
     }
    procedure CertNameItemFields(CertName: PCertNameBLOB;
      Params, Values: TStrings; IsAscendingOrder: Boolean);
    {   FieldName   CertName, 
        CertNameItemFields,  
    IsAscendingOrder      
      }
    function CertNameItemField(CertName: PCertNameBLOB;
      const FieldName: string; IsAscendingOrder: Boolean): string;
    {    CertName   ,
    IsAscendingOrder    , 
    IsSorted = True     X500ToStr}
    function CertNameItem(CertName: PCertNameBLOB;
      IsAscendingOrder, IsSorted: Boolean): string;
    {   }
    procedure CertIssuerFields(CertInfo: PCertInfo; Params, Values: TStrings);
    {    ( ,   )}
    function CertIssuerField(CertInfo: PCertInfo;
      const FieldName: string): string;
    {      }
    function CertIssuer(CertInfo: PCertInfo): string;
    {   }
    procedure CertSubjectFields(CertInfo: PCertInfo;
      Params, Values: TStrings);
    {    ( ,   )}
    function CertSubjectField(CertInfo: PCertInfo;
      const FieldName: string): string;
    {      }
    function CertSubject(CertInfo: PCertInfo): string;
    {   }
    procedure RequestSubjectFields(RequestInfo: PCertRequestInfo;
      Params, Values: TStrings);
    {    ( ,   )}
    function RequestSubjectField(RequestInfo: PCertRequestInfo;
      const FieldName: string): string;
    {      }
    function RequestSubject(RequestInfo: PCertRequestInfo): string;
    {      
         }
    function BinCertNameToStr(const Value: string): string;
    {  PropId    CertContext, 
     ,     (CertProperty); , 
        (CertPropertyStr)}
    function CertProperty(CertContext: PCCertContext;
      PropId: DWORD): TSizedBufInfo;
    function CertPropertyStr(CertContext: PCCertContext;
      PropId: DWORD): string;
    { ; CertStr -  ,  
      ;  CheckDate = True,   
          , 
    ActualDate;  IsLocalDate = True ,  ActualDate 
     ,   ;  WithPrivateKey = True 
       ,     
     Provider, Container -    ,  
       ,    ;
           KeyProvInfo 
          CRYPT_KEY_PROV_INFO, 
      ,  ECryptoAPINoCertError,  NoError
     False       ,
     nil, Index    , 0 - 
     }
    function CertFind(const CertFindInfo: TCertFindInfo; Index: Integer;
      out KeyProvInfo: TSizedBufInfo; NoError: Boolean): PCCertContext;
    {  ; CertStr -     Base64
    ;  FieldName  Request.ClientCertificate  ASP:
    'Certificate' - ,       ;
    'SerialNumber' -       
    ; 'ValidFrom' -     ( 
    dd.mm.yyyy hh:nn:ss); 'ValidUntil' -    
    (  dd.mm.yyyy hh:nn:ss); 'Subject' -  
    ('SubjectCN', 'SubjectO'  .. -    
    ); 'Issuer' -   ('IssuerCN', 'IssuerO' 
    .. -     ); 'Version' - 
    ; 'SignatureAlgorithm' -  ; 'Algorithm' - 
     ; 'PublicKey' -     
     ; 'PublicKeyBits' -     ;
    'AlgName' -       ,
           CertSign,
    CertVerify, 'Thumbprint' -     
     ; 'CertName' -   CertStr,
        X500, 'CertNameCN' -  , 'CertNameO' -
      .. -     X500,   
       : 'Request' - ,   
       ; 'RequestSubject' -  () 
    ('RequestSubjectCN', 'RequestSubjectO'  .. -   
     ); 'RequestVersion' -   ;
    'RequestAlgorithm' -    ;
    'RequestPublicKey' -     ;
    'RequestPublicKeyBits' -      ;
    'RequestAlgName' -      
    ,       
    CertSign, CertVerify (   ,     
    ,     ;  RSA  SHA1),
     IsSign = True      
        GetValueFromArray}
    function CertField(const CertStr: string; IsSign: Boolean;
      const FieldName: string): string;
    {     }
    procedure CryptVerifyCert(const CertStr, CACertStr, CACRLStr: string);
    {   CertStr    
    CACertStr,  ,      
    CACertificates,   nil,    
    ,      ECryptoAPICertValidityError
          
    ECryptoAPICertValidityRevokeError,  ,  AllowExpired
      ECryptoAPICertValidityTimeError}
    procedure VerifyCert(const CertStr, CACertStr: string;
      AllowExpired: Boolean; CACertificates: TStrings);
    {    StoreName   CertFindInfo,  
           ,  
           
        KeyProvInfo,     
    ,    ,  ECryptoAPINoCertError,
     NoError  True       ,
      , IsMachineKeyset     
     , Index    , 0 - 
    }
    function FindCertInStore(const StoreName: string;
      const CertFindInfo: TCertFindInfo; Index: Integer;
      IsMachineKeyset: Boolean; out KeyProvInfo: TSizedBufInfo;
      NoError: Boolean): string;
    {      StoreName   
    Subjects     Issuers, IsWithPrivateKey 
             ,
    IsMachineKeyset        ,
       ,     Subjects
       (-1),     
     ,    CertStr    
           ,  Certificates
      nil   ,    
     ,   Certificates}
    function FindNewestCertInStore(const StoreName: string; Subjects,
      Issuers: TStrings; IsWithPrivateKey, IsMachineKeyset: Boolean;
      out CertStr: string; Certificates: TStrings): Integer;
    {     Certificates,   nil,
          ,  ,
    ,     ,  (-1)
            }
    function FindNewestCert(Certificates: TStrings): Integer;
    {   ;   CertStr,
           CRLStr,    ),
    IsMachineKeyset       ,
     UseExisting  True   ,   
     }
    procedure AddCertToStore(const StoreName, CertStr, CRLStr: string;
      IsMachineKeyset, UseExisting: Boolean);
    {  CertList,   nil,   
    StoreName,  IsMachineKeyset  True   
    ,   ,  KeysList,   nil, 
       TSizedBufInfo      
    TCryptKeyProvInfo}
    procedure CertsInStore(const StoreName: string; IsMachineKeyset: Boolean;
      CertList: TStringList; KeysList: TList);
    {  }
    function CryptSignByCert(CertContext: PCCertContext;
      ProvInfo: PCryptKeyProvInfo; const DataStr: string): string;
    { }
    procedure CryptVerifyByCert(CertContext: PCCertContext;
      ProvHandle: THCryptProv; const DataStr, Signature: string);
    {   }
    function SignByCert(const DataStr, StoreName, CertStr,
      SerialNumber: string; IsMachineKeyset: Boolean; IssuerAbbrs,
      IssuerValues, SubjectAbbrs, SubjectValues: TStrings): string;
    {    }
    procedure VerifyByCert(const DataStr, Signature, StoreName,
      CertStr, SerialNumber: string; CheckDate: Boolean;
      SignatureDate: TDateTime; IsLocalDate: Boolean;
      IssuerAbbrs, IssuerValues, SubjectAbbrs, SubjectValues: TStrings);
    {    }
    procedure VerifyByCertStr(const DataStr, Signature, CertStr: string);
    {}
    {   ,  UseCertKeyFormat = True 
           , 
           
     PublicKeyData}
    function CertGenReqSrv(Alg: TCryptoAlgorithm; const Subject: TX500;
      UseCertKeyFormat: Boolean; out PublicKeyData, PublicKey: string): string;
    { , ,  , ,  
     ,  IsFile = True ,  Data, SourData,
    DestData -    , XXXXMulti -     
    GetStrFromArray, CertVerifyMulti      
    ,     -   , 
    UseCertKeyFormat = True      
      ,     
         PublicKeyData, IsMachineKeyset
         ,
     IsExpCertificate      
       ExpCertificate,  InsCertToSign  
        AddValueToArray  ,  IsCertInStr
        ,  AddCertToStore 
        ,    ,  
         CACertStr
         ,
     AllowExpired = True    
    ,  CACertificates <> nil   
            
       CACertificates,      
    ,      IsCertInStr  True
     IsFile  False     
            OwnCert, ClientCert
          ,  
     ,        
         ,   ,
           , ,
       ,  ClientCerts   
          
    ,   , ClientCertCheck,   nil, 
          ,
    ,   }
    function CertGenReq(Alg: TCryptoAlgorithm; const Subject: TX500;
      UseCertKeyFormat: Boolean; out PublicKeyData, PublicKey: string): string;
    function CertSign(Alg: TCryptoAlgorithm; const OwnStoreName, Data: string;
      const OwnCert: TCertFindCfg; IsMachineKeyset, IsFile, IsCaching,
      IsExternal, IsExpCertificate: Boolean; out ExpCertificate: string;
      InsCertToSign: Boolean): string;
    function CertSignMulti(Alg: TCryptoAlgorithm; const OwnStoreName,
      Data: string; const OwnCert: TCertFindCfg; IsMachineKeyset, IsFile,
      IsCaching, IsExternal, IsMulti, IsExpCertificate: Boolean;
      out ExpCertificate: string; InsCertToSign: Boolean): string;
    procedure CertVerify(Alg: TCryptoAlgorithm; const OwnStoreName,
      ClientStoreName, Data, Signature: string; const OwnCert,
      ClientCert: TCertFindCfg; IsOwnCertDefined, IsMachineKeyset, IsFile,
      IsCaching, IsExternal, IsCertInStr, AddCertToStore: Boolean;
      const CACertStr: string; AllowExpired: Boolean;
      CACertificates: TStrings);
    function CertVerifyMulti(Alg: TCryptoAlgorithm; const OwnStoreName,
      ClientStoreName, Data, Signature: string; const OwnCert,
      ClientCert: TCertFindCfg; IsOwnCertDefined, IsMachineKeyset, IsFile,
      IsCaching, IsExternal, IsMulti, IsCertInStr, AddCertToStore: Boolean;
      const CACertStr: string; AllowExpired: Boolean;
      CACertificates: TStrings): string;
    procedure CertProtect(Alg: TCryptoAlgorithm; const SourData: string;
      var DestData: string; const SymmetricKey: string; const OwnCert,
      ClientCert: TCertFindCfg; IsFile, IsCaching, IsExternal,
      IsCertInStr: Boolean);
    procedure CertUnprotect(Alg: TCryptoAlgorithm;
      const SourData: string; var DestData: string; const SymmetricKey: string;
      const OwnCert, ClientCert: TCertFindCfg; IsFile, IsCaching,
      IsExternal, IsCertInStr: Boolean; const CACertStr: string;
      AllowExpired: Boolean; CACertificates: TStrings;
      ClientCertCheck: TCAPICertCheckMethod);
    {   ,  
    Certificate,   ,    
    CertFindStoreName   CertFindCfg,  CertFindWithPrivateKey
     True -       , 
       , CertFindWithPrivateKey  False -
      , Wnd -  , Title -
    }
    function CertView(const Certificate, CertFindStoreName: string;
      const CertFindCfg: TCertFindCfg; CertFindWithPrivateKey: Boolean;
      Wnd: HWND; const Title: string): Boolean;
    {}
    {    (SysGen),   
    (SysGenSymmetric),      
     (SysProtectSymmetric),      
    (SysCertRequest),   (SysSign),   (SysVerify),
        ,    Datas,
      Signatures,    ClientPublicKeys,
     Errors         
       (SysVerifyMulti),  (SysProtect), 
    (SysUnprotect)   ; Alg -   (:
    caRSA  caGOST, caGOST2001 - CryptoPro); Data, SourData, DestData -
    / ,   IsFile = True ,   
      ,  IsFile = False - ; OwnPrivateKey,
    OwnPublicKey -        ; 
      ClientPublicKey -     ; 
     / ClientKey -    
    ,  IsSymmetric = True,   IsSymmetric = False - 
        ,  UseCertKeyFormat = True 
           , 
           
     PublicKeyData, DestFilePos  ,   
        ,   
        ,  ,
    SourFilePos  ,      
     }
    procedure SysGen(Alg: TCryptoAlgorithm; out PrivateKey,
      PublicKey: string; UseSysContainer, IsMachineKeyset,
      UseCertKeyFormat: Boolean);
    function SysGenSymmetric(Alg: TCryptoAlgorithm; var OwnPrivateKey: string;
      const OwnPublicKey: string; IsMachineKeyset: Boolean): string;
    function SysProtectSymmetric(Alg: TCryptoAlgorithm;
      var OwnPrivateKey: string; const OwnPublicKey, SymmetricKey,
      ClientPublicKey: string; IsMachineKeyset: Boolean): string;
    function SysCertRequest(Alg: TCryptoAlgorithm; var OwnPrivateKey: string;
      const Subject: TX500; IsMachineKeyset: Boolean): string;
    function SysSign(Alg: TCryptoAlgorithm; const Data: string;
      var OwnPrivateKey: string; IsFile, IsMachineKeyset: Boolean): string;
    procedure SysVerify(Alg: TCryptoAlgorithm; const Data, Signature: string;
      var OwnPrivateKey: string; const ClientPublicKey: string; IsFile,
      IsMachineKeyset: Boolean);
    procedure SysVerifyMulti(Alg: TCryptoAlgorithm; const Datas,
      Signatures: TStrings; var OwnPrivateKey: string;
      const ClientPublicKeys: TStrings; IsFile, IsMachineKeyset: Boolean;
      Errors: TExceptionsInfoLists);
    procedure SysProtect(Alg: TCryptoAlgorithm; const SourData: string;
      var DestData, OwnPrivateKey: string; const OwnPublicKey,
      ClientKey: string; IsSymmetric, IsFile, IsMachineKeyset: Boolean;
      DestFilePos: Integer);
    procedure SysUnprotect(Alg: TCryptoAlgorithm; const SourData: string;
      var DestData, OwnPrivateKey: string; const OwnPublicKey,
      ClientKey: string; IsSymmetric, IsFile, IsMachineKeyset: Boolean;
      SourFilePos: Integer);
    {}
    {        CryptoAPI
        ParentHandle,  Title,
     AlgName,      ,
      Title   ,   
      AllowExpired   , 
     StoreName,  ,   
    Certificate,     SerualNumber, 
    ,    ActualSysDate,  Issuer,
     Subject,    Data,  IsMulti = True
      ,     
    GetStrFromArray,   UserName, ,  
    ,    ,   Mode,  Params,
     IsMulti = True   GetStrFromArray,  ,
      Data,     AddField
      Data,     OnDefineData, 
       True,  False}
    function SignDlg(ParentHandle: HWND; const Title, AlgName: string;
      var StoreName, Certificate, SerialNumber: string;
      var ActualSysDate: TDateTime; var Issuer, Subject: string;
      const Data: string; IsMulti: Boolean; const UserName, Mode,
      Params: string; OnDefineData: TDefineDataEvent): Boolean;
    function VerifyDlg(ParentHandle: HWND; const Title, AlgName: string;
      var AllowExpired: Boolean; const StoreName, Certificate,
      SerialNumber: string; ActualSysDate: TDateTime; Issuer, Subject,
      Data: string; IsMulti: Boolean; const UserName, Mode, Params: string;
      OnDefineData: TDefineDataEvent): Boolean;
    {  TCertContextRetrieveEvent, Sender  
      TTransport   TTransport.Storage 
    TTransportDBStorage      
    TTransportDBStorage.DatabaseAccess,   
    TTransportStorage.OwnerId,   CERTOWNERS  
      ,      'MY'
        ,  CERTOWNERS 
      'CO_ID'   , 'CO_TYPE'  ,
     'T'  , 'CO_ORGANIZATIONID'  
     , 'CO_USERLOGIN'   ,
       ,    'CO_SUBJECTCN',
    'CO_SUBJECTT', 'CO_SUBJECTOU', 'CO_SUBJECTO', 'CO_SUBJECTL', 'CO_SUBJECTS',
    'CO_SUBJECTC', 'CO_SUBJECTE', 'CO_SUBJECTOTHER', 'CO_ISSUERCN',
    'CO_ISSUERT', 'CO_ISSUEROU', 'CO_ISSUERO', 'CO_ISSUERL', 'CO_ISSUERS',
    'CO_ISSUERC', 'CO_ISSUERE', 'CO_ISSUEROTHER'}
    procedure ClientCertContextRetrieve(Sender: TObject;
      var CertContext: Pointer; var Store: DWORD);
    {}
    {     Alg  Data  
     ,       
    OwnCert,     ClientCert, IsCaching 
     ,     ProtectedMsgToStr
    (CertProtectMsg);       Alg  Data
      ProtectedMsgToStr    , 
         ,   Data,  
      ClientCert,      
    ClientCertFindMethod  ,   Data, IsCaching 
     ,    (CertUnprotectMsg);
       Alg  Data    ,
           OwnCert, IsCaching 
     ,     SignedMsgToStr
    (CertSignMsg);     Alg  Data, 
      Signature   SignedMsgToStr,  
     ,        OwnCert,
    ClientCert    ,   
       ClientCertFindMethod  ,   Signature,
    IsCaching   ,    
       CACertStr  
       ,  AllowExpired = True 
       ,  CACertificates
      nil     
            
     CACertificates,       }
    function CertProtectMsg(Alg: TCryptoAlgorithm; const Data: string;
      const OwnCert: TCertFindCfg; const ClientCert: string;
      IsCaching: Boolean): string;
    function CertUnprotectMsg(Alg: TCryptoAlgorithm; const Data: string;
      const ClientCert: string; ClientCertFindMethod:
      TThumbprintCNToCertMethod; IsCaching: Boolean): string;
    function CertSignMsg(Alg: TCryptoAlgorithm; const Data: string;
      const OwnCert: TCertFindCfg; IsCaching: Boolean): string;
    procedure CertVerifyMsg(Alg: TCryptoAlgorithm; const Data,
      Signature: string; const OwnCert: TCertFindCfg; const ClientCert: string;
      ClientCertFindMethod: TThumbprintCNToCertMethod; IsCaching: Boolean;
      const CACertStr: string; AllowExpired: Boolean;
      CACertificates: TStrings);
    {}
    { SID   - (CProSID);  -, 1 -
             34.10-94, 2 -
        , 3 -     , 4 -
      ,      34.10-94,
         34.10-2001,    -
     3.6   2008     34.10-94  , 0 -
      ,   ,   -  ,
            4 (CProVersion);
       -   
      34.10-94        ,
       34.10-2001     34.10-94
         ,   True
    (CProAllowProvSubst);   ,  
       34.10-2001    34.10-94,  
     4-  (CProProvSubst)}
    property CProSID: string read GetCProSID;
    property CProVersion: Integer read GetCProVersion;
    property CProAllowProvSubst: Boolean
      read FCProAllowProvSubst write FCProAllowProvSubst;
    property CProProvSubst: string read FCProProvSubst;
    {   OID (OIDs); 
      OID,    OIDs
    (OIDNames)}
    property OIDs: TIndexedStrings read GetOIDs;
    property OIDNames: TIndexedStrings read GetOIDNames;
    {  ,     
       (ProviderTypes);    
    (ProviderTypesInfo);   (ProviderNames);  
      (ProviderNameTypes);   
    (ProviderNamesInfo);    
    (ProviderDefAlgsInfo);      ProviderIndex,
             
           
        (ProviderAlgs);     
       ProviderIndex (ProviderAlgsInfos)}
    property ProviderTypes: TIndexedList read GetProviderTypes;
    property ProviderTypesInfo: TCryptoProviderTypesInfo
      read GetProviderTypesInfo;
    property ProviderNames: TIndexedStrings read GetProviderNames;
    property ProviderNameTypes: TIndexedList read GetProviderNameTypes;
    property ProviderNamesInfo: TCryptoProviderNamesInfo
      read GetProviderNamesInfo;
    property ProviderAlgs[ProviderIndex: Integer]: TIndexedList
      read GetProviderAlgs;
    property ProviderAlgsInfos[ProviderIndex: Integer]:
      TCryptoProviderAlgsInfo read GetProviderAlgsInfos;
    property ProviderDefAlgsInfo[ProviderIndex: Integer]:
      TCryptoProviderDefAlgInfo read GetProviderDefAlgInfo;
    {}
    {     ,    nil}
    property CryptoAPICACache: TCryptoAPICACache
      read FCryptoAPICACache write FCryptoAPICACache;
    {        , 
     CryptoExternalDefWaitTime}
    property CryptoExternalWaitTime: Integer
      read FCryptoExternalWaitTime write FCryptoExternalWaitTime;
    {   Windows}
    property LastError: Integer read FLastError;
    {   ,  AT_KEYEXCHANGE}
    property DefKeySpec: DWORD read FDefKeySpec write FDefKeySpec;
    {    }
    property DefMyStoreName: string read FDefMyStoreName write FDefMyStoreName;
    {  ,     
    }
    property DefContainer: string read FDefContainer write FDefContainer;
    {       }
    property DefRequestStoreName: string
      read FDefRequestStoreName write FDefRequestStoreName;
    {       ,
      False}
    property NotUserProtect: Boolean
      read FNotUserProtect write FNotUserProtect;
    { CALG_SIMPLE_EXPORT   CALG_PRO_EXPORT}
    property SimpleExport: Boolean read FSimpleExport write FSimpleExport;
    {   ,    
    (KeyInitVector);       
     ,   False (NoBlocksHashing);    
            
         CertFind (CertFindSerialAsThumbprint)}
    property KeyInitVector: string read FKeyInitVector write FKeyInitVector;
    property NoBlocksHashing: Boolean
      read FNoBlocksHashing write FNoBlocksHashing;
    property CertFindSerialAsThumbprint: Boolean
      read FCertFindSerialAsThumbprint write FCertFindSerialAsThumbprint;
    {,        
     ,      
     CAService, ,   WindowsAPI.RestartService,
            
         ECryptoAPICAError}
    property CAValidityPeriod: TPeriod
      read GetCAValidityPeriod write SetCAValidityPeriod;
    { ,   CertRequest (ExternalCert)}
    property ExternalCert: string read FExternalCert write FExternalCert;
    {      ,  ,
      CertRequest (FQDNs)}
    property FQDNs: string read FFQDNs write FFQDNs;
    {   ,  ,   ,
        DefContainer (RequestGenKey); 
         caGOST, caGOST2001,
      szOID_KP_RA_USER,  , ,
    szOID_KP_RA_CLIENT_AUTH     ","
    (AdditionalGostCertUsages)}
    property RequestGenKey: Boolean read FRequestGenKey write FRequestGenKey;
    property AdditionalGostCertUsages: string
      read FAdditionalGostCertUsages write FAdditionalGostCertUsages;
    {      CertProtect,
       CertUnprotect (ClientCerts);  
        ProcessData,   
    CertProtect  ClientCerts    
    ClientCerts.Changed  True,     
     False,   CertGenReqSrv, CertGenReq, CertSign, CertSignMulti,
    CertVerify, CertVerifyMulti, CertUnprotect, SysGen, SysGenSymmetric,
    SysProtectSymmetric, SysCertRequest, SysSign, SysVerify, SysVerifyMulti,
    SysUnprotect, CertProtectMsg, CertUnprotectMsg  
        (ClientCertsInfo)}
    property ClientCerts: TCertFindsCfg read GetClientCerts;
    property ClientCertsInfo: TCertFindsInfo read GetClientCertsInfo;
    {   ,   
           ,
      False,      
       ,     
             
     }
    property NotAllowCombinedKeyCaching: Boolean
      read FNotAllowCombinedKeyCaching write FNotAllowCombinedKeyCaching;
  end;
{}
{       
CryptoAPI,  ,   
    (CryptoAPICACache);   
   CryptoAPI,  
(CryptoAPICACacheReset)}
function CryptoAPICACache: TCryptoAPICACache;
procedure CryptoAPICACacheReset;
{       CryptoAPI, 
      (CryptoAPI); 
   CryptoAPI  (CryptoAPIReset)}
function CryptoAPI: TCryptoAPI;
procedure CryptoAPIReset;
{   'CAPIEX.EXE'}
procedure CAPIExRun;

{ Crypto-API }
const
  CryptAppLibCryptoAPI = 'CRYPTOAPI';
  CryptAppLibCryptoAPIPostfix = 'G';
type
  {  : catArcmailEmul -  
        Arcmail, catCrpGostEmul -  
  CRP_GOST}
  TCryptAppType = (catArcmailEmul, catCrpGostEmul);
  {  : camUnknown -    
  , camGenerate -   , camProtect -
   , camUnprotect -  }
  TCryptAppMode = (camUnknown, camGenerate, camProtect, camUnprotect);
  TCryptAppParams = record
    Mode: TCryptAppMode;     {Arcmail: a - , u - }
    SourFile: string;        {Arcmail:  -lFILENAME}
    DestClientsFile: string; {Arcmail:  -jFILENAME}
    DestFile: string;        {Arcmail,  : -mFILENAME}
    DestPath: string;        {Arcmail,  : -yFILEPATH}
    ResLogFile: string;      {Arcmail: -oFILENAME}
    LogFile: string;         {Arcmail: -zFILENAME}
  end;
  TNullCryptAppParams = record
    NotNull: Boolean;
    Value: TCryptAppParams;
  end;
  {  ,       :
  g#CLIEN#secCLIEN.key#pubCLIEN.key#PassCLIEN#,   
     ClientPublicKey}
  TCryptAppParamItem = record
    Mode: TCryptAppMode;     {CrpGost: e - , d - }
    SourFile: string;        {CrpGost: 1-  "IN"}
    DestFile: string;        {CrpGost: 2-  "OUT"}
    KeysName: string;        {CrpGost: 4-  "ARM_CRIPT_ID"}
    PrivateKey: string;      {CrpGost: 7-/4-    "sec"}
    Password: string;        {CrpGost: 5-/3-,  "ARM_CRIPT_ID"/"pws"}
    ClientKeysName: string;  {CrpGost: 3-  "cript"}
    ClientPublicKey: string; {CrpGost: 4-/5-  "pub"}
    ParamStr: string;        {CrpGost:   }
  end;
  PCryptAppParamItem = ^TCryptAppParamItem;
{   Value (InitCryptAppParams);   
TCryptApp (CryptAppParamsEmpty);   TCryptAppParams
  Mode,   SourFile,   DestClientsFile,
    DestFile,    
 DestPath,   ResLogFile,  LogFile
(CryptAppParams);    Value (InitNullCryptAppParams);
   TNullCryptAppParams  , 
Null (NullCryptAppParamsEmpty);   TNullCryptAppParams 
  Null NotNull   Value (NullCryptAppParams);
   Value (InitCryptAppParamItem)}
procedure InitCryptAppParams(out Value: TCryptAppParams);
function CryptAppParamsEmpty: TCryptAppParams;
function CryptAppParams(Mode: TCryptAppMode; const SourFile, DestClientsFile,
  DestFile, DestPath, ResLogFile, LogFile: string): TCryptAppParams;
procedure InitNullCryptAppParams(out Value: TNullCryptAppParams);
function NullCryptAppParamsEmpty: TNullCryptAppParams;
function NullCryptAppParams(NotNull: Boolean;
  const Value: TCryptAppParams): TNullCryptAppParams;
procedure InitCryptAppParamItem(out Value: TCryptAppParamItem);
{  TCryptAppParamItem}
type
  TCryptAppParamList = class(TObjectStd)
  private
    FList: TList;
    FChanged: Boolean;
  protected
    function GetCapacity: Integer;
    procedure SetCapacity(NewCapacity: Integer);
    function GetCount: Integer;
    procedure SetCount(NewCount: Integer);
    function GetItem(Index: Integer): TCryptAppParamItem;
    procedure SetItem(Index: Integer; const Value: TCryptAppParamItem);
    function GetItemPtr(Index: Integer): PCryptAppParamItem;
  public
    constructor Create;
    destructor Destroy; override;
    {}
    {  (Clear);   Value,   
    (Add);   Value   Index (Insert); 
       Index (Delete)}
    procedure Clear;
    function Add(const Value: TCryptAppParamItem): Integer;
    procedure Insert(Index: Integer; const Value: TCryptAppParamItem);
    procedure Delete(Index: Integer);
    {}
    {  (Capacity);   (Count);  
       Index (Items);     ,
        nil (ItemPtrs);   
    True,   ,     (Changed)}
    property Capacity: Integer read GetCapacity write SetCapacity;
    property Count: Integer read GetCount write SetCount;
    property Items[Index: Integer]: TCryptAppParamItem
      read GetItem write SetItem; default;
    property ItemPtrs[Index: Integer]: PCryptAppParamItem read GetItemPtr;
    property Changed: Boolean read FChanged write FChanged;
  end;
{}
{,   ,  
-}
type
  TBaseCryptApp = class(TObjectStd)
  private
    FAppType: TCryptAppType;
    FAlgName: string;
    FGenLibName: string;
    FPassword: string;
    FHide: Boolean;
    FKeyVer: string;
    FPrivateKeyFullName: string;
    FPublicKeyAlias: string;
    FPublicKeyFullName: string;
    FClientKeyFullName: string;
    FClientKeysPath: string;
    FIncludeBaseKeyName: Boolean;
    FPrivateKeyFullNameCryptoAPI: string;
    FPublicKeyFullNameCryptoAPI: string;
    FParams: TNullCryptAppParams;
    FParamList: TCryptAppParamList;
    FRaiseError: Boolean;
    FCmdLineStr: string;
  protected
    {  (ParamCount);     
    Index (ParamStr)}
    function ParamCount: Integer;
    function ParamStr(Index: Integer): string;
    { True,    , 
      False (SupportMultiLibs);   
    PublicKey  ,    
    CryptAppLibCryptoAPI,   ,  PrivateKeyFullName,
    PublicKeyFullName      
            
    PrivatKeyFullNameCryptoAPI, PublicKeyFullNameCryptoAPI,    ,
     CryptAppLibCryptoAPIPostfix     
    (PublicKeyToLib);     LibName,  
     PrivateKeyFile,    PublicKeyFile, 
       ClientPublicKey,    
      DestFilePos (LibProtect);    
    LibName,    PrivateKeyFile,   
    PublicKeyFile,     ClientPublicKey, 
        SourFilePos (LibUnprotect)}
    function SupportMultiLibs: Boolean; virtual;
    function PublicKeyToLib(const PublicKey: string; out PrivateKeyFullName,
      PublicKeyFullName: string): string; virtual;
    procedure LibProtect(const SourFile, DestFile, LibName, PrivateKeyFile,
      PublicKeyFile, ClientPublicKey: string; DestFilePos: Integer); virtual;
    procedure LibUnprotect(const SourFile, DestFile, LibName, PrivateKeyFile,
      PublicKeyFile, ClientPublicKey: string; SourFilePos: Integer); virtual;
    {}
    procedure ArcmailEmulProcess;
    procedure CrpGostEmulProcess;
  public
    constructor Create;
    {}
    {     ,  
    ConfigFullName,    -   ,   
      '.ini',     'MAIN' - 
      'APPTYPE',  'ARCMAIL'   -  
       Arcmail, 'CRP_GOST' -   CRP_GOST, 
      'ALGNAME',    'GOST', 'HIDE' -  
    1     , 'DEBUGMODE' -  ,
      'INFO'     , 'KEYVER' -
      ,   ,  , 
      - 'PRVKEY',  -  'PUBKEY',     -
      'DIRKEYS' (LoadConfig);   
       (RetrieveParams);   
      , ,    (RetrieveParamList); 
     (GenKeys);   SourFile   
     DestFile,       
    ClientPublicKeyName  ,    ClientKeysPath,
       ClientKeyFullName,     ,
     CheckPublicKey  True   ,  
    False,     ,   True
    (Protect);   SourFile     DestFile,
      ClientPublicKeyName      
     ,    ,    
    ClientKeyFullName,    ,  CheckPublicKey
     True   ,   False, 
       ,   True (Unprotect)}
    procedure LoadConfig(const ConfigFullName: string); virtual;
    function RetrieveParams: TCryptAppParams;
    procedure RetrieveParamList(ParamList: TCryptAppParamList);
    procedure GenKeys; virtual;
    function Protect(const SourFile, DestFile, ClientPublicKeyName: string;
      CheckPublicKey: Boolean; const LibName: string): Boolean; virtual;
    function Unprotect(const SourFile, DestFile: string;
      out ClientPublicKeyName: string; CheckPublicKey: Boolean;
      const LibName: string): Boolean; virtual;
    {}
    { ,       
           ,
       ConfigFullName c  LoadConfig,
    ,   ,    ,  ,
          
    PrivateKeyFullName, Password,    Null,
    PublicKeyFullName, ClientKeysPath ,   
     Params,   ,  Null,  
     RetrieveParams,  RaiseError = True   
     ,     , ParamList 
        ,   
    CmdLineStr,   ,    
    }
    procedure Process(const ConfigFullName, PrivateKeyFullName: string;
      const Password: TNullStr; const PublicKeyFullName, ClientKeysPath:
      string; const Params: TNullCryptAppParams; ParamList: TCryptAppParamList;
      RaiseError: Boolean; const CmdLineStr: string);
    {}
    { ,   catArcmailEmul (AppType); ,
      'GOST' (AlgName);   ,  
    CryptAppLibCryptoAPI (GenLibName);  (Password);  
      ,   False (Hide);    
    ;   ,   ,  
    (KeyVer); (PrivateKeyFullName);   , 
      ,  , , 'bank.pub',   , 
     PublicKeyFullName   (PublicKeyAlias);   
      (PublicKeyFullName);     
    ,   ,   ClientKeysPath    
       (ClientKeyFullName);     
        (ClientKeysPath);   
        (IncludeBaseKeyName); ,   
    Process,     AppType = catArcmailEmul, 
      RetrieveParams (Params);   CryptoAPI
    (PrivateKeyFullNameCryptoAPI);   CryptoAPI
    (PublicKeyFullNameCryptoAPI);     ,
       Process,     AppType = catCrpGostEmil,
          RetrieveParamList (ParamList);
         ,   False,
      Process (RaiseError);   , 
     ,     (CmdLineStr)}
    property AppType: TCryptAppType read FAppType write FAppType;
    property AlgName: string read FAlgName write FAlgName;
    property GenLibName: string read FGenLibName write FGenLibName;
    property Password: string read FPassword write FPassword;
    property Hide: Boolean read FHide write FHide;
    property KeyVer: string read FKeyVer write FKeyVer;
    property PrivateKeyFullName: string
      read FPrivateKeyFullName write FPrivateKeyFullName;
    property PublicKeyAlias: string read FPublicKeyAlias write FPublicKeyAlias;
    property PublicKeyFullName: string
      read FPublicKeyFullName write FPublicKeyFullName;
    property ClientKeyFullName: string
      read FClientKeyFullName write FClientKeyFullName;
    property ClientKeysPath: string read FClientKeysPath write FClientKeysPath;
    property IncludeBaseKeyName: Boolean
      read FIncludeBaseKeyName write FIncludeBaseKeyName;
    property PrivateKeyFullNameCryptoAPI: string
      read FPrivateKeyFullNameCryptoAPI write FPrivateKeyFullNameCryptoAPI;
    property PublicKeyFullNameCryptoAPI: string
      read FPublicKeyFullNameCryptoAPI write FPublicKeyFullNameCryptoAPI;
    property Params: TNullCryptAppParams read FParams write FParams;
    property ParamList: TCryptAppParamList read FParamList write FParamList;
    property RaiseError: Boolean read FRaiseError write FRaiseError;
    property CmdLineStr: string read FCmdLineStr write FCmdLineStr;
  end;
{}
{     TBaseCryptApp, 
      (BaseCryptApp);
  TBaseCryptApp  (BaseCryptAppReset)}
function BaseCryptApp: TBaseCryptApp;
procedure BaseCryptAppReset;

